/*
* [azarec.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/


/***********************************************************************

	gcjAzaRec Function : ڎR[h֐

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"


/*-------------------------
	ϐ
---------------------------
*/

	/* ڎR[ht@C */
static AZA_HEADER 		m_AzaHeader;
static AZA_TABLE_LIST	m_azaTableList[ CHO_MAX ];
static AZA_RECORD 		*m_aryRecord;

static int m_maxNumTables;
static int m_numTables;
static int m_numTotalRecords;


/*-------------------------
	֐
---------------------------
*/

int GetChomokuNum( char *str, int *matchLength );
extern char *sjispbrk( char *str, char *chars );



/*---------------------------------------------------------------------

	ڎR[ht@C̓eɊi[B
	
	(in)
		fileName : ڎR[ht@C̖
	
	E͂̊֐ŊmۂB
	ȄIAAzaRecEnd()ĂяoŃJB
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : mۂłȂ
			-2 : t@CI[vłȂ
			-3 : t@CID̕񂪈Ⴄ
			-4ȍ~ : t@C̃[hG[
			
-----------------------------------------------------------------------
*/

int AzaRecLoad( char *fileName )
{
	FILE *fpRec;
	int n,nRet;
	
	fpRec = fopen( fileName, "rb" );
	if ( fpRec == NULL ) return -2;
	
	/* wb_[ */
	n = fread( &m_AzaHeader, sizeof( m_AzaHeader ), 1, fpRec );
	if ( n != 1 ) { nRet = -4; goto err; }

	if ( strcmp( m_AzaHeader.fileId, FILE_ID_AZA ) ) { nRet = -3; goto err; }

	m_maxNumTables = m_AzaHeader.maxNumTables;
	m_numTables = m_AzaHeader.numTables;
	m_numTotalRecords = m_AzaHeader.numTotalRecords;
	
	/* e[uXg */
	n = fread( m_azaTableList, sizeof( m_azaTableList ), 1, fpRec);
	if ( n != 1 ){ nRet = -5; goto err; }

	/* R[h{ */
	m_aryRecord = (AZA_RECORD*) malloc( sizeof(AZA_RECORD) * m_numTotalRecords );
	if ( ! m_aryRecord ){ nRet = -1; goto err; }

	n = fread( m_aryRecord, sizeof(AZA_RECORD), m_numTotalRecords, fpRec );
	if ( n != m_numTotalRecords ) { nRet = -6; goto err; }
	
	fclose( fpRec );
	return m_numTotalRecords;

err:
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	fclose( fpRec );
	return nRet;
}



/*---------------------------------------------------------------------

	ɂ钚ڎR[h̓et@CɏށB
	
	(in)
		fileName : ڎR[ht@C̖
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : t@CI[vłȂ
			-2ȍ~ : t@C̃CgG[
			
-----------------------------------------------------------------------
*/

int AzaRecSave( char *fileName )
{
	FILE *fpRec;
	int n,nRet;
	
	fpRec = fopen( fileName, "wb" );
	if ( fpRec == NULL ) return -1;
	
	/* wb_[ */
	n = fwrite( &m_AzaHeader, sizeof( m_AzaHeader ), 1, fpRec );
	if ( n != 1 ) { nRet = -2; goto err; }

	/* e[uXg */
	n = fwrite( m_azaTableList, sizeof( m_azaTableList ), 1, fpRec);
	if ( n != 1 ){ nRet = -3; goto err; }

	/* R[h{ */
	n = fwrite( m_aryRecord, sizeof(AZA_RECORD), m_numTotalRecords, fpRec );
	if ( n != m_numTotalRecords ) { nRet = -4; goto err; }
	
	fclose( fpRec );
	return m_numTotalRecords;

err:
	fclose( fpRec );
	return nRet;
}


/*---------------------------------------------------------------------

	ڎR[h̏Is
	
	EmۂJB
	
	߂l
		0 : 	I
		
-----------------------------------------------------------------------
*/

int AzaRecEnd()
{
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	
	return 0;
}

/*---------------------------------------------------------------------

	w肵s撬A厚̒ڎR[h̐擾B
	
	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		
	߂l
		0ȏ : ڎR[h
		F	G[
			-1 : ڎR[hɃ[hĂȂ
			-2 : s撬R[h͈̔̓G[
			-3 : 厚R[h擾łȂ
			-4 : e[uXg̃f[^ُ
			
-----------------------------------------------------------------------
*/

int AzaRecNumRecords( int cityCode, int choCode )
{
	CHO_RECORD choRecord;
	int nRet,tableNum;
	
	if ( ! m_aryRecord  ) return -1;
	if ( cityCode < 1000 || cityCode >= GYOSEI_MAX ) return -2;

	/* 厚R[h̎擾 */
	nRet = ChoRecGet( cityCode ,choCode, &choRecord );
	if ( nRet < 0 ) {
		return -3;
	}
	
	/* ڎe[uԍ̎擾 */
	tableNum = choRecord.azaTableNum;
	
	if ( cityCode != m_azaTableList[ tableNum ].cityCode ||
			choCode != m_azaTableList[ tableNum ].choCode ){
		return -4;
	}
	
	return m_azaTableList[ tableNum ].numRecords;
}



/*---------------------------------------------------------------------

	ڎR[h擾B
	
	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h
		
	(out)
		AzaRecord : ڎR[h
		
	߂l
		0 : 	I
		F	G[
			-1 : 厚R[hɃ[hĂȂ
			-2 : s撬R[h͈̔̓G[
			-3 : 厚R[h͈̔̓G[
			-4 : e[uXg̃f[^ُ
			-5 : ڎR[h͈̔̓G[
			-6 : ڎR[h̃f[^ُ
			
-----------------------------------------------------------------------
*/

int AzaRecGet( int cityCode, int choCode, int azaCode, 
												AZA_RECORD *azaRecord )
{
	int startRecNum,numRecords,nRet,tableNum;
	CHO_RECORD choRecord;
	
	if ( ! m_aryRecord  ) return -1;
	if ( cityCode < 1000 || cityCode >= GYOSEI_MAX ) return -2;

	/* 厚R[h̎擾 */
	nRet = ChoRecGet( cityCode ,choCode, &choRecord );
	if ( nRet < 0 ) {
		return -3;
	}
	
	/* ڎe[uԍ̎擾 */
	tableNum = choRecord.azaTableNum;
	
	if ( cityCode != m_azaTableList[ tableNum ].cityCode ||
			choCode != m_azaTableList[ tableNum ].choCode ){
		return -4;
	}

	/* ڎR[h͈̔̓`FbN */	
	numRecords = m_azaTableList[ tableNum ].numRecords;
	if ( azaCode <= 0 || azaCode > numRecords ) {
		return -5; 
	}

	/* ڎR[h̎擾 */
	startRecNum = m_azaTableList[ tableNum ].startRecNum;

	memcpy( azaRecord, m_aryRecord + startRecNum + azaCode - 1, sizeof( AZA_RECORD ));

	if ( azaRecord->choazaCode != ( (choCode << 16) + azaCode ) ){
		return -6;
	}
	
	return 0;
}


/*---------------------------------------------------------------------

	ڎR[hݒ肷B
	
	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h
		AzaRecord : ڎR[h
		
	߂l
		0 : 	I
		F	G[
			-1 : 厚R[hɃ[hĂȂ
			-2 : s撬R[h͈̔̓G[
			-3 : 厚R[h͈̔̓G[
			-4 : e[uXg̃f[^ُ
			-5 : ڎR[h͈̔̓G[
			-6 : Rs[撚ڎR[h̃f[^ُ

	E̊֐́Ałɂ郌R[ĥłAVK̃R[h
	@쐬łȂB
	E̊֐̓ɂ郌R[hύX邾łB
	@ۂɃt@CύXɂ́AAzaRecSave()sB
			
-----------------------------------------------------------------------
*/

int AzaRecPut( int cityCode, int choCode, int azaCode, 
												AZA_RECORD *azaRecord )
{
	int startRecNum,numRecords,nRet,tableNum;
	AZA_RECORD *orgAzaRecord;
	CHO_RECORD choRecord;
	
	if ( ! m_aryRecord  ) return -1;
	if ( cityCode < 1000 || cityCode >= GYOSEI_MAX ) return -2;

	/* 厚R[h̎擾 */
	nRet = ChoRecGet( cityCode ,choCode, &choRecord );
	if ( nRet < 0 ) {
		return -3;
	}
	
	/* ڎe[uԍ̎擾 */
	tableNum = choRecord.azaTableNum;
	
	if ( cityCode != m_azaTableList[ tableNum ].cityCode ||
			choCode != m_azaTableList[ tableNum ].choCode ){
		return -4;
	}

	/* ڎR[h͈̔̓`FbN */	
	numRecords = m_azaTableList[ tableNum ].numRecords;
	if ( azaCode <= 0 || azaCode > numRecords ) {
		return -5; 
	}

	/* ̒ڎR[h̎擾 */
	startRecNum = m_azaTableList[ tableNum ].startRecNum;

	orgAzaRecord = m_aryRecord + startRecNum + azaCode - 1;
	if ( orgAzaRecord->choazaCode != ( (choCode << 16) + azaCode ) ){
		return -6;
	}

	/* ̒ڎR[hVK̂̂ɐݒ */
	memcpy( orgAzaRecord, azaRecord, sizeof( AZA_RECORD ));

	return 0;
}


/*---------------------------------------------------------------------

	Z̐擪ɂ钚ڎAڎ̃R[h
	擾B
	
	(in)
		azaTableNum : ڎe[uԍ
		str        : Z
	(out)
		matchLength : }b`O񕔕̃oCg
		azaRecord   : ڎ̃R[h
		  
	߂l
			 1 : 
			 0 : Ȃ
			 -1: ڎe[u[hĂȂ
			 -2: e[uԍG[
			 -3: NULL

	EoCiT[`Aڂ̃_CNgANZX邱ƁB
	
		
-----------------------------------------------------------------------
*/
int AzaRecSearch( int azaTableNum, char *str, 
								int *matchLength, AZA_RECORD *azaRecord )
{
	int numRecords,i,chomokuNum;
	AZA_RECORD *pRecord;

	if ( ! m_aryRecord ) return -1;
	if ( m_numTables <= azaTableNum ) return -2;
	if ( ! matchLength  || ! azaRecord ) return -3;
	
	pRecord = m_aryRecord + m_azaTableList[ azaTableNum ].startRecNum;
	numRecords = m_azaTableList[ azaTableNum ].numRecords;

	chomokuNum = GetChomokuNum( str, matchLength );

	/* ڐ̏ꍇ */
	if ( chomokuNum ){
		for ( i = 0; i < numRecords; i++ ){
			if ( chomokuNum == GetChomokuNum( pRecord->name, 0 )) break;
			pRecord++;
		}
		if ( i == numRecords ) goto nomatch;
	}
	else{
		for ( i = 0; i < numRecords; i++ ){
			if ( strstr( str, pRecord->name )) break;
			pRecord++;
		}
		if ( i == numRecords ) goto nomatch;
		*matchLength = strlen( pRecord->name ) ;
	}
	
	memcpy( azaRecord, pRecord, sizeof(AZA_RECORD) );
	return 1;

nomatch:
	*matchLength = 0;
	return 0;
}


/*
	̐擪ɂ钚ڐ擾B

	(in)
		str : 

	(out)
		matchLength : ڕ̒("""["܂ށj
		              svȏꍇNULL

	߂l 
		1ȏF@ڐ
		0@@F@ڂł͂Ȃ
		
	EڐƂ݂Ȃ
	@Zp̕т̌オ
	@"","|","[","\","]","-","","m"
	@̂ꂩ̕ŏI镶B
	  
*/
int GetChomokuNum( char *str, int *matchLength )
{
	char *pChome;
	int nMatch,numValue;
	
	numValue = NumStr2Int( str, &nMatch );
	if ( nMatch == 0 ) {
		if ( matchLength ) *matchLength = 0;
		return 0;
	}
	if ( matchLength == NULL ) return numValue;
	
	pChome = strstr( str, "" );
	if ( ! pChome ) {
		pChome = sjispbrk( str, "|[\]-̃m" );
		if ( ! pChome ) goto ret;
		else {
			nMatch = pChome - str + 1;
			if ( IsSjisKanji(pChome) ) nMatch++;
		}
	}
	else nMatch = pChome + 4 - str;

ret:
	*matchLength = nMatch;
	return numValue;
}

