/*
* [chimei25krec.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/***********************************************************************

	Chimei25kRec Function : 25000nR[h֐

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"

/*-------------------------
	ϐ
---------------------------
*/

	/* 25000nR[ht@C */
static CHIMEI25K_HEADER m_chimeiHeader;
static CHIMEI25K_RECORD *m_aryRecord;

static int m_numRecords;

/*---------------------------------------------------------------------

	25000nR[ht@C̓eɊi[B
	
	(in)
		fileName : 25000nR[ht@C̖
	
	E͂̊֐ŊmۂB
	ȄIAChimei25kRecEnd()ĂяoŃJB
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : mۂłȂ
			-2 : t@CI[vłȂ
			-3 : t@CID̕񂪈Ⴄ
			-4ȍ~ : t@C̃[hG[
			
-----------------------------------------------------------------------
*/

int Chimei25kRecLoad( char *fileName )
{
	FILE *fpRec;
	int n,nRet;
	
	fpRec = fopen( fileName, "rb" );
	if ( fpRec == NULL ) return -2;
	
	/* wb_[ */
	n = fread( &m_chimeiHeader, sizeof( m_chimeiHeader ), 1, fpRec );
	if ( n != 1 ) { nRet = -4; goto err; }

	if ( strcmp( m_chimeiHeader.fileId, FILE_ID_CHIMEI25K ) ) { nRet = -3; goto err; }
	m_numRecords = m_chimeiHeader.numRecords;
	
	/* R[h{ */
	m_aryRecord = (CHIMEI25K_RECORD*) malloc( sizeof(CHIMEI25K_RECORD) * m_numRecords );
	if ( ! m_aryRecord ){ nRet = -1; goto err; }

	n = fread( m_aryRecord, sizeof(CHIMEI25K_RECORD), m_numRecords, fpRec );
	if ( n != m_numRecords ) { nRet = -6; goto err; }
	
	fclose( fpRec );
	return m_numRecords;

err:
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	fclose( fpRec );
	return nRet;
}


/*---------------------------------------------------------------------

	25000nR[h̏Is
	
	EmۂJB
	
	߂l
		0 : 	I
		
-----------------------------------------------------------------------
*/

int Chimei25kRecEnd()
{
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	
	return 0;
}

/*---------------------------------------------------------------------

	25000nR[h̐擾B
	
		
	߂l
		0ȏ : 25000nR[h
		F	G[
			-1 : 25000nR[hɃ[hĂȂ
			
-----------------------------------------------------------------------
*/

int Chimei25kRecNumRecords()
{
	if ( ! m_aryRecord  ) return -1;
	
	return m_numRecords;	
}

/*---------------------------------------------------------------------

	25000nR[h擾B
	
	(in)
		chimeiCode : 25000nR[h

	(out)
		chimei25kRecord : 25000nR[h
		
	߂l
		  0 : I
		F	G[
			-1 : 25000nR[hɃ[hĂȂ
			-2 : 25000nR[h͈̔̓G[
			-3 : R[hԍG[
			
-----------------------------------------------------------------------
*/

int Chimei25kRecGet( int chimeiCode , CHIMEI25K_RECORD *chimei25kRecord )
{
	
	if ( ! m_aryRecord ) return -1;
	
	if ( chimeiCode < 0 ) return -2;
	
	if ( chimeiCode >= m_numRecords ) return -3;
	
	memcpy( chimei25kRecord, &m_aryRecord[ chimeiCode ], sizeof( CHIMEI25K_RECORD ));

	return 0;	
}

