/*
* [chorec.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/***********************************************************************

	gcjChoRec Function : 厚R[h֐

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"

/*-------------------------
	ϐ
---------------------------
*/

	/* 厚R[ht@C */
static CHO_HEADER 		m_choHeader;
static CHO_OFFSET 		m_recOffset[ GYOSEI_MAX ];
static CHO_RECORD 		*m_aryRecord;

static int m_numTotalRecords;

/*---------------------------------------------------------------------

	厚R[ht@C̓eɊi[B
	
	(in)
		fileName : 厚R[ht@C̖
	
	E͂̊֐ŊmۂB
	ȄIAgcjChoRecEnd()ĂяoŃJB
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : mۂłȂ
			-2 : t@CI[vłȂ
			-3 : t@CID̕񂪈Ⴄ
			-4ȍ~ : t@C̃[hG[
			
-----------------------------------------------------------------------
*/

int ChoRecLoad( char *fileName )
{
	FILE *fpRec;
	int n,nRet;
	
	fpRec = fopen( fileName, "rb" );
	if ( fpRec == NULL ) return -2;
	
	/* wb_[ */
	n = fread( &m_choHeader, sizeof( m_choHeader ), 1, fpRec );
	if ( n != 1 ) { nRet = -4; goto err; }

	if ( strcmp( m_choHeader.fileId, FILE_ID_CHO ) ) { nRet = -3; goto err; }
	m_numTotalRecords = m_choHeader.numRecords;
	
	/* R[hԍe[u */
	n = fread( m_recOffset, sizeof( m_recOffset ), 1, fpRec);
	if ( n != 1 ){ nRet = -5; goto err; }

	/* R[h{ */
	m_aryRecord = (CHO_RECORD*) malloc( sizeof(CHO_RECORD) * m_numTotalRecords );
	if ( ! m_aryRecord ){ nRet = -1; goto err; }

	n = fread( m_aryRecord, sizeof(CHO_RECORD), m_numTotalRecords, fpRec );
	if ( n != m_numTotalRecords ) { nRet = -6; goto err; }
	
	fclose( fpRec );
	return m_numTotalRecords;

err:
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	fclose( fpRec );
	return nRet;
}



/*---------------------------------------------------------------------

	ɂ钬厚R[h̓et@CɏށB
	
	(in)
		fileName : 厚R[ht@C̖
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : t@CI[vłȂ
			-2ȍ~ : t@C̃CgG[
			
-----------------------------------------------------------------------
*/

int ChoRecSave( char *fileName )
{
	FILE *fpRec;
	int n,nRet;
	
	fpRec = fopen( fileName, "wb" );
	if ( fpRec == NULL ) return -1;
	
	/* wb_[ */
	n = fwrite( &m_choHeader, sizeof( m_choHeader ), 1, fpRec );
	if ( n != 1 ) { nRet = -2; goto err; }

	/* R[hԍe[u */
	n = fwrite( m_recOffset, sizeof( m_recOffset ), 1, fpRec);
	if ( n != 1 ){ nRet = -3; goto err; }

	/* R[h{ */
	n = fwrite( m_aryRecord, sizeof(CHO_RECORD), m_numTotalRecords, fpRec );
	if ( n != m_numTotalRecords ) { nRet = -4; goto err; }
	
	fclose( fpRec );
	return m_numTotalRecords;

err:
	fclose( fpRec );
	return nRet;
}


/*---------------------------------------------------------------------

	厚R[h̏Is
	
	EmۂJB
	
	߂l
		0 : 	I
		
-----------------------------------------------------------------------
*/

int ChoRecEnd()
{
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	
	return 0;
}

/*---------------------------------------------------------------------

	w肵s撬̒厚R[h̐擾B
	
	(in)
		cityCode : s撬R[hiTj
		
	߂l
		0ȏ : 厚R[h
		F	G[
			-1 : 厚R[hɃ[hĂȂ
			-2 : s撬R[h͈̔̓G[
			
-----------------------------------------------------------------------
*/

int ChoRecNumRecords( int cityCode )
{
	int numRecords;
	
	if ( ! m_aryRecord  ) return -1;
	if ( cityCode < 1000 || cityCode >= GYOSEI_MAX ) return -2;
	
	numRecords = m_recOffset[ cityCode ].numRecords;

	return numRecords;	
}



/*---------------------------------------------------------------------

	厚R[h擾B
	
	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
	(out)
		choRecord : 厚R[h
		
	߂l
		0 : 	I
		F	G[
			-1 : 厚R[hɃ[hĂȂ
			-2 : s撬R[h͈̔̓G[
			-3 : 厚R[h͈̔̓G[
			
-----------------------------------------------------------------------
*/

int ChoRecGet( int cityCode ,int choCode, CHO_RECORD *choRecord )
{
	int startRecNum,numRecords;
	
	if ( ! m_aryRecord  ) return -1;
	
	if ( cityCode < 1000 || cityCode >= GYOSEI_MAX ) return -2;
	
	startRecNum = m_recOffset[ cityCode ].startRecNum;

	numRecords = m_recOffset[ cityCode ].numRecords;
	if ( choCode <= 0 || choCode > numRecords ) {
		return -3; 
	}

	memcpy( choRecord, m_aryRecord + startRecNum + choCode - 1, sizeof( CHO_RECORD ));

	return 0;	
}


/*---------------------------------------------------------------------

	厚R[hݒ肷B

	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		choRecord : 厚R[h
		
	߂l
		0 : 	I
		F	G[
			-1 : 厚R[hɃ[hĂȂ
			-2 : s撬R[h͈̔̓G[
			-3 : 厚R[h͈̔̓G[
			
	E̊֐̓ɂ郌R[hύX邾łB
	@ۂɃt@CύXɂ́AChoRecSave()sB
	
-----------------------------------------------------------------------
*/

int ChoRecPut( int cityCode ,int choCode, CHO_RECORD *choRecord )
{
	int startRecNum,numRecords;
	
	if ( ! m_aryRecord  ) return -1;
	
	if ( cityCode < 1000 || cityCode >= GYOSEI_MAX ) return -2;
	
	startRecNum = m_recOffset[ cityCode ].startRecNum;

	numRecords = m_recOffset[ cityCode ].numRecords;
	if ( choCode <= 0 || choCode > numRecords ) return -3; 

	memcpy( m_aryRecord + startRecNum + choCode - 1, choRecord, sizeof( CHO_RECORD ));

	return 0;	
}

