/*
* [gaikurec.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/* Todo : nԂ̌oCiT[`ɂB
*/


/***********************************************************************

	gcjGaikuRec Function : nԊX敄R[h֐

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"


/*-------------------------
	ϐ
---------------------------
*/

	/* nԊX敄R[ht@C */
static GAIKU_HEADER 		m_gaikuHeader;
static GAIKU_TABLE_LIST		*m_gaikuTableList;
static GAIKU_RECORD 		*m_aryRecord;

static int m_numTables;
static int m_numTotalRecords;

	/* nԕt@C */

static STRING_HEADER m_stringHeader;
static STR_RECORD *m_stringRecord;
static int m_stringNumRecords;

/*-------------------------
	֐
---------------------------
*/
int GetGaikuTableNum( int cityCode, int choCode, int azaCode );
int GetGaikuNum( char *str, int *matchLength );
int GetGaikuStr( int chibanStrNum, char *gaikuStr, int strMax );


/*---------------------------------------------------------------------

	nԊX敄R[ht@C̓eɊi[B
	
	(in)
		recordFileName : nԊX敄R[ht@C̖
		stringFileName : nԕ񃌃R[ht@C̖
	
	Ê̓tpXŎw
	E͂̊֐ŊmۂB
	ȄIAGaikuRecEnd()ĂяoŃJB
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : mۂłȂ
			-2 : t@CI[vłȂ
			-3 : t@CID̕񂪈Ⴄ
			-4ȍ~ : t@C̃[hG[
			
-----------------------------------------------------------------------
*/

int GaikuRecLoad( char *recordFileName, char *stringFileName )
{
	FILE *fpRec,*fpStr;
	int n,nRet;

	fpRec = fpStr = NULL;
	
	if ( m_gaikuTableList ) return m_numTotalRecords;	/*@łɃ[hς */
		
	fpRec = fopen( recordFileName, "rb" );
	if ( fpRec == NULL ) return -2;
	
	/* nԊX敄t@C */
		/* wb_[ */
	n = fread( &m_gaikuHeader, sizeof( m_gaikuHeader ), 1, fpRec );
	if ( n != 1 ) { nRet = -4; goto err; }

	if ( strcmp( m_gaikuHeader.fileId, FILE_ID_GAIKU ) ) { nRet = -3; goto err; }

	m_numTables = m_gaikuHeader.numTables;
	m_numTotalRecords = m_gaikuHeader.numTotalRecords;
	
		/* e[uXg */
	m_gaikuTableList = (GAIKU_TABLE_LIST*) malloc( sizeof(GAIKU_TABLE_LIST) * m_numTables );
	if ( ! m_gaikuTableList ){ nRet = -1; goto err; }
	n = fread( m_gaikuTableList, sizeof( GAIKU_TABLE_LIST ), m_numTables, fpRec);
	if ( n != m_numTables ){ nRet = -5; goto err; }

		/* R[h{ */
	m_aryRecord = (GAIKU_RECORD*) malloc( sizeof(GAIKU_RECORD) * m_numTotalRecords );
	if ( ! m_aryRecord ){ nRet = -1; goto err; }

	n = fread( m_aryRecord, sizeof(GAIKU_RECORD), m_numTotalRecords, fpRec );
	if ( n != m_numTotalRecords ) { nRet = -6; goto err; }
	
	/* nԕt@C */
	fpStr = fopen( stringFileName, "rb" );
	if ( fpStr != NULL ) {
			/*@wb_[ */
		n = fread( &m_stringHeader, sizeof( m_stringHeader ), 1, fpStr );
		if ( n != 1 ) { nRet = -8; goto err; }

		if ( strcmp( m_stringHeader.fileId, FILE_ID_STRING ) ) { nRet = -9; goto err; }
	
		m_stringNumRecords = m_stringHeader.numRecords;

			/*@R[h */
		m_stringRecord = (STR_RECORD*) malloc( sizeof(STR_RECORD) * m_stringNumRecords );
		if ( ! m_stringRecord ){ nRet = -10; goto err; }
	
		n = fread( m_stringRecord, sizeof(STR_RECORD), m_stringNumRecords, fpStr );
		if ( n != m_stringNumRecords ) { nRet = -11; goto err; }
	}
	
	if ( fpRec ) fclose( fpRec );
	if ( fpStr ) fclose( fpStr );
	
	return m_numTotalRecords;

err:
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	if ( m_gaikuTableList ) {
		free( m_gaikuTableList );
		m_gaikuTableList = NULL;
	}

	if ( m_stringRecord ) {
		free( m_stringRecord );
		m_stringRecord = NULL;
	}
	
	if ( fpRec ) fclose( fpRec );
	if ( fpStr ) fclose( fpStr );

	return nRet;
}



/*---------------------------------------------------------------------

	ɂnԊX敄R[h̓et@CɏށB
	
	(in)
		fileName : nԊX敄R[ht@C̖
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : t@CI[vłȂ
			-2ȍ~ : t@C̃CgG[
			
-----------------------------------------------------------------------
*/

int GaikuRecSave( char *fileName )
{
	FILE *fpRec;
	int n,nRet;
	
	fpRec = fopen( fileName, "wb" );
	if ( fpRec == NULL ) return -1;
	
	/* wb_[ */
	n = fwrite( &m_gaikuHeader, sizeof( m_gaikuHeader ), 1, fpRec );
	if ( n != 1 ) { nRet = -2; goto err; }

	/* e[uXg */
	n = fwrite( m_gaikuTableList, sizeof( GAIKU_TABLE_LIST ), m_numTables, fpRec);
	if ( n != m_numTables ){ nRet = -3; goto err; }

	/* R[h{ */
	n = fwrite( m_aryRecord, sizeof(GAIKU_RECORD), m_numTotalRecords, fpRec );
	if ( n != m_numTotalRecords ) { nRet = -4; goto err; }
	
	fclose( fpRec );
	return m_numTotalRecords;

err:
	fclose( fpRec );
	return nRet;
}


/*---------------------------------------------------------------------

	nԊX敄R[h̏Is
	
	EmۂJB
	
	߂l
		0 : 	I
		
-----------------------------------------------------------------------
*/

int GaikuRecEnd()
{
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	if ( m_gaikuTableList ) {
		free( m_gaikuTableList );
		m_gaikuTableList = NULL;
	}
	
	if ( m_stringRecord ) {
		free( m_stringRecord );
		m_stringRecord = NULL;
	}

	return 0;
}

/*---------------------------------------------------------------------

	w肵s撬A厚Aڎ̒nԊX敄R[h擾B
	
	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h(0)
		
	߂l
		0ȏ : nԊX敄R[h
		F	G[
			-100ԑ : nԊX敄e[uԍ̎擾G[
			           GetGaikuTableNum()Q
			
-----------------------------------------------------------------------
*/

int GaikuRecNumRecords( int cityCode, int choCode, int azaCode )
{
	int tableNum;
	
	tableNum = GetGaikuTableNum( cityCode, choCode, azaCode );
	if ( tableNum <= 0 ) return tableNum;
		
	return m_gaikuTableList[ tableNum ].numRecords;
}

/*---------------------------------------------------------------------

	nԊX敄R[ḧꗗinԊX敄R[h̃Xgj擾B

	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h(0)
		recordMax : R[hԍi[z̗vf
	(out)
		codeArray : R[hԍi[z

	߂l
		0ȏ : R[h
		F	G[
			-100ԑ : nԊX敄e[uԍ̎擾G[
			           GetGaikuTableNum()Q
-----------------------------------------------------------------------
*/

int GaikuRecGetList( int cityCode, int choCode, int azaCode, 
								int *codeArray, int recordMax )
{
	GAIKU_RECORD *pRecord;
	int i,tableNum,numRecords;
	
	tableNum = GetGaikuTableNum( cityCode, choCode, azaCode );
	if ( tableNum < 0 ) return tableNum;
	if ( tableNum == 0 ) return 0;

	numRecords = m_gaikuTableList[ tableNum ].numRecords;
	pRecord = m_aryRecord + m_gaikuTableList[ tableNum ].startRecNum;

	for ( i = 0; i < numRecords; i++ ){
		if ( i == recordMax ) break;
		codeArray[ i ] = pRecord->gaikuCode;
		pRecord++;
	}
	
	return i;
}

/*---------------------------------------------------------------------

	nԊX敄R[h擾B

	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h(0)
		gaikuCode : nԊX敄R[hinԊX敄̏ꍇ͂̐A
		@@@@@@@@@@@@@@@@̏ꍇ͕ԍj
	(out)
		gaikuRecord : 擾nԊX敄R[h
		jukyoHyoji  : Z\tOi0:Z\łȂ@1:Z\łj

	߂l
		0 : 	I

		F	G[
			-1 : w肳ꂽnԊX敄e[uɖ
			-2 : gaikuRecordNULL|C^
			-100ԑ : nԊX敄e[uԍ̎擾G[
			           GetGaikuTableNum()Q
-----------------------------------------------------------------------
*/

int GaikuRecGet( int cityCode, int choCode, int azaCode, int gaikuCode, 
								GAIKU_RECORD *gaikuRecord, int *jukyoHyoji )
{
	GAIKU_RECORD *pRecord;
	int i,tableNum,numRecords;
	
	tableNum = GetGaikuTableNum( cityCode, choCode, azaCode );
	if ( tableNum < 0 ) return tableNum;
	if ( tableNum == 0 ) return -1;

	numRecords = m_gaikuTableList[ tableNum ].numRecords;
	pRecord = m_aryRecord + m_gaikuTableList[ tableNum ].startRecNum;
	*jukyoHyoji = m_gaikuTableList[ tableNum ].jukyoHyoji;

	for ( i = 0; i < numRecords; i++ ){
		if ( gaikuCode == pRecord->gaikuCode ) break;
		pRecord++;
	}

	if ( i < numRecords ){
		if ( gaikuRecord ){
			memcpy( gaikuRecord, pRecord, sizeof( GAIKU_RECORD ) );
			return 0;
		}
		else return -1;
	}
	else return -1;
}


/*---------------------------------------------------------------------

	nԊX敄R[hݒ肷B
	
	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h(0)
		gaikuCode : nԊX敄R[hinԊX敄̏ꍇ͂̐A
		@@@@@@@@@@@@@@@@̏ꍇ͕ԍj
		gaikuRecord : ݒ肷nԊX敄R[h
		
	߂l
		0 : 	I
		F	G[
			-1 : w肳ꂽnԊX敄e[uɖ
			-100ԑ : nԊX敄e[uԍ̎擾G[
			           GetGaikuTableNum()Q

	E̊֐́Ałɂ郌R[ĥłAVK̃R[h
	@쐬łȂB
	E̊֐̓ɂ郌R[hύX邾łB
	@ۂɃt@CύXɂ́AGaikuRecSave()sB
			
-----------------------------------------------------------------------
*/

int GaikuRecPut( int cityCode, int choCode, int azaCode, int gaikuCode, 
												GAIKU_RECORD *gaikuRecord )
{
	GAIKU_RECORD *pRecord;
	int i,tableNum,numRecords;
	
	tableNum = GetGaikuTableNum( cityCode, choCode, azaCode );
	if ( tableNum < 0 ) return tableNum;
	if ( tableNum == 0 ) return -1;

	numRecords = m_gaikuTableList[ tableNum ].numRecords;
	pRecord = m_aryRecord + m_gaikuTableList[ tableNum ].startRecNum;

	for ( i = 0; i < numRecords; i++ ){
		if ( gaikuCode == pRecord->gaikuCode ) break;
		pRecord++;
	}

	if ( i < numRecords ){
		memcpy( pRecord, gaikuRecord, sizeof( GAIKU_RECORD ) );
		return 0;
	}
	else return -1;
}


/*---------------------------------------------------------------------

	Z̐擪ɂnԊX敄AnԊX敄̃R[h
	ԂB
	
	(in)
		gaikuTableNum : nԊX敄e[uԍ
		str        : Z
	(out)
		matchLength : }b`O񕔕̃oCg
		gaikuReocrd : nԊX敄̃R[h
		  
	߂l
			 1 : 
			 0 : Ȃ
			 -1: nԊX敄R[hɃ[hĂȂ
			 -2: e[uԍG[


	EoCiT[`Aڂ̃_CNgANZX邱ƁB
		
-----------------------------------------------------------------------
*/
int GaikuRecSearch( int gaikuTableNum, char *str, 
							int *matchLength, GAIKU_RECORD *gaikuRecord )
{
	int numRecords,i,gaikuNum,gCode,nRet;
	GAIKU_RECORD *pRecord;
	char gaikuStr[STRMAX+1];

	if ( ! m_aryRecord ) return -1;
	if ( gaikuTableNum >= m_numTables ) return -2;
	
	pRecord = m_aryRecord + m_gaikuTableList[ gaikuTableNum ].startRecNum;
	numRecords = m_gaikuTableList[ gaikuTableNum ].numRecords;

	gaikuNum = GetGaikuNum( str, matchLength );
	if ( gaikuNum ) {	/*@nԊX敄̏ꍇ */
		for ( i = 0; i < numRecords; i++ ){
			if ( gaikuNum == pRecord->gaikuCode ) break;
			pRecord++;
		}
		if ( i == numRecords ) return 0;
	}
	else {	/* nԊX敄̏ꍇ */
		for ( i = 0; i < numRecords; i++ ){
			gCode = pRecord->gaikuCode;
			if ( gCode < 0 ){
				nRet = GetGaikuStr( -gCode, gaikuStr, STRMAX );
				if ( nRet < 0 )  continue;
				
				if ( strstr( str, gaikuStr )) break;
			}
			pRecord++;
		}
		if ( i == numRecords ) return 0;
		*matchLength = strlen( gaikuStr );
	}
	
	memcpy( gaikuRecord, pRecord, sizeof(GAIKU_RECORD) );
	return 1;
}


/*@w肵厚ђڎɑ΂AnԊX敄e[u̔ԍ擾B

	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h(0)


	߂l
		1ȏ : e[uԍ
		   0  : w肳ꂽ厚Aڎɂ͒nԊX敄e[u
			     o^ĂȂ
		  FG[
			-101 : nԊX敄R[hɃ[hĂȂ
			-102 : 厚R[h擾łȂ
			-103 : ڎR[h擾łȂ
			-104 : e[uXg̃f[^ُ

*/

int GetGaikuTableNum( int cityCode, int choCode, int azaCode )
{
	CHO_RECORD choRecord;
	AZA_RECORD azaRecord;
	int nRet,tableNum;
	
	if ( ! m_aryRecord  ) return -101;

	/* ڎȂ厚̏ꍇ */
	if ( azaCode <= 0 ){
		/* 厚R[h̎擾 */
		nRet = ChoRecGet( cityCode ,choCode, &choRecord );
		if ( nRet < 0 ) {
			return -102;
		}
		tableNum = choRecord.chibanTableNum;
	}
	/* ڎ厚̏ꍇ */
	else {
		/* ڎR[h̎擾 */
		nRet = AzaRecGet( cityCode ,choCode, azaCode, &azaRecord );
		if ( nRet < 0 ) {
			return -103;
		}
		tableNum = azaRecord.chibanTableNum;
	}
	if ( ! tableNum ) return 0;
	
	if ( cityCode != m_gaikuTableList[ tableNum ].cityCode ||
			choCode != m_gaikuTableList[ tableNum ].choCode ){
		return -104;
	}
	return tableNum;
}

/*@nԕ擾B

	(in)
		chibanStrNum : nԕԍ
		strMax : obt@igaikuStrj̃oCg
	(out)
		gaikuStr : nԕ
		
	߂l
	@@@ 0 ; I
		 : G[
		  -1 ; nԕ񃌃R[hɃ[hĂȂ
		  -2 : XR[hɑΉ郌R[hȂ
		  -3 : obt@̒Ȃ
*/

int GetGaikuStr( int chibanStrNum, char *gaikuStr, int strMax )
{
	char *p;
	
	if ( ! m_stringRecord ) return -1;

	if ( chibanStrNum < 0 ) chibanStrNum = chibanStrNum;	
	if ( chibanStrNum >= m_stringNumRecords ) return -2;
	
	p = m_stringRecord[ chibanStrNum ].str;
	if ( strlen(p) >= (unsigned int)strMax ) return -4;
	
	strcpy( gaikuStr, p );
	
	return 0;
}





/*
	̐擪ɂԒnAX敄擾B

	(in)
		str : 

	(out)
		matchLength : ڕ̒("""["܂ށj
		              svȏꍇNULL

	߂l 
		1ȏF@ԒnAX敄ȉꍇj
		0@@F@̔ԒnAX敄ł͂Ȃ
		
	EԒnAX敄Ƃ݂Ȃ
	
	@Zp̕т̌オ
	@"","Ԓn","X", "|","[","\","]","","m"
	@̂ꂩ̕ŏI镶B
	@܂́ȀȈꍇB
	  
*/
		
int GetGaikuNum( char *str, int *matchLength )
{
	char *pChome;
	int nMatch,numValue;
	
	numValue = NumStr2Int( str, &nMatch );
	if ( nMatch == 0 ) {
		if ( matchLength ) *matchLength = 0;
		return 0;
	}
	if ( matchLength == NULL ) return numValue;
	
	pChome = strstr( str, "Ԓn" );
	if ( ! pChome ) {
		pChome = sjispbrk( str, "ԁ|[\]-̃m" );
		if ( ! pChome ) {
			pChome = strstr( str, "X" );
			if  (! pChome ) goto ret;
			else nMatch = pChome + 4 - str;
		}
		else {
			nMatch = pChome - str + 1;
			if ( IsSjisKanji(pChome) ) nMatch++;
		}
	}
	else nMatch = pChome + 4 - str;

ret:
	*matchLength = nMatch;
	return numValue;
}


