/*
* [gcjadrfilter.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/***********************************************************************

     	gcj filter : ̕ϊ֐
     	
************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "geocoder.h"
#include "gcjlib.h"

#define STRMAX 1023
typedef unsigned short USHORT;

/*-------------------------
	ϐ
---------------------------
*/
extern int g_encoding;		/* 0:SJIS 1:EUCJP 2:UTF8 */

/*-------------------------
	֐
---------------------------
*/

extern int IsSjisKanji( char *p );
static int RemoveSpace( char *fromStr, char *toStr, int toStrMax );




/* ZϊB

	(in)
		filterNum : ϊ̎ނ\ԍ
		fromStr   : ϊO̕
		toStrMax  : ϊ̕i[obt@̃oCg
		
	(out)
		toStr     : ϊ̕
	
	߂l=@0FI
	          FG[
	          -1FR[hϊ̃G[

	EfilterNum =
				1: 󔒕iXy[XA^uj菜
				
	F̊֐ł͕ϊVtgJISR[hōsĂB̂
	@@VtgJISȊO̕R[h̏ꍇ̓R[hϊ̎ԂB
*/

int gcjAdrFilter( int filterNum, char *fromStr, char *toStr, int toStrMax )
{
	int nret;
	char fromStrBuff[STRMAX+1],*pFromStr;
	char toStrBuff[STRMAX+1];

	/* R[hVtgJIS֕ϊ */
	if ( g_encoding ){
		int mode;
		if ( g_encoding == EUCJP ) mode = EUCJP2SJIS;
		else if ( g_encoding == UTF8 ) mode = UTF82SJIS;
		else return -1;
		nret = gcjCharConv( mode, fromStr, fromStrBuff, STRMAX );
		if ( nret < 0 ) return -1;
		pFromStr = fromStrBuff;
	}
	else pFromStr = fromStr;
	
	/* ۂ̏VtgJISōs */
	
	strcpy( toStrBuff, "" );
	switch ( filterNum ){
		case 1:
			nret = RemoveSpace( pFromStr, toStrBuff, STRMAX );
	}

	/* VtgJIS猳̕R[h֕ϊ */
	if ( g_encoding ){
		int mode,nRet;

		if ( g_encoding == EUCJP ) mode = SJIS2EUCJP;
		else if ( g_encoding == UTF8 ) mode = SJIS2UTF8;
		else return -1;
		
		nRet = gcjCharConv( mode, toStrBuff, toStr, toStrMax );
		if ( nRet < 0 ) return -1;

	}
	else gcjStrcpy( toStr, toStrBuff, toStrMax );

	return 0;
}


/* 󔒕iXy[XA^uj菜

	߂l@Rs[oCg
*/

static int RemoveSpace( char *fromStr, char *toStr, int toStrMax )
{
	char *p;
	int toCounter,copyBytes;
	USHORT kanjiSpace = *(USHORT*)"@";
	
	if ( toStrMax <= 0 ) return 0;
	
	p = fromStr;
	toCounter = 0;
	while( *p ){
		if ( IsSjisKanji( p ) ){
			if ( *(USHORT*)p == kanjiSpace ) {
				p += 2;
				continue;
			}
			else copyBytes = 2;
		}
		else{
			if ( *p == ' ' || *p == '\t' ) {
				p++;
				continue;
			}
			else copyBytes = 1;
		}
		
		if ( toCounter + copyBytes < toStrMax ){
			*toStr++ = *p++;
			if ( copyBytes == 2 ) *toStr++ = *p++;
			
			toCounter += copyBytes;
		}
		else break;
	}
	
	*toStr = '\0';
	
	return toCounter;
}

