/*
* [gcjadrstr2code.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/


/***********************************************************************

						ʗpZ֐

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"

#define TRUE 1
#define FALSE 0


static int GetSjisCharLength( char *str, int bytes );
extern int g_encoding;		/* 0:SJIS 1:EUCJP 2:UTF8 */


/*---------------------------------------------------------------------

	ZZR[hɕϊB
	
	(in)
		adrStr   : Z
	(out)
		adrCode   : ZR[h\
	
	߂l
		  1ȏ  : R[hɕϊł̕
		  0      : w肳ꂽZ͏ZDBɂ͓o^ĂȂ
		 F	G[
		 -1  : Z̓ɊYs於Bʂ
		 @@@s於iS⌧jKvB
		 -2  : ُiZ񂪋󂩁AadrCodeNULLȂ)
		 -3ȉ : ̃G[
	
-----------------------------------------------------------------------
*/

#define CODE_MAX 100


int gcjAdrStr2Code( char *adrStr, ADR_CODE *adrCode )
{
	int i,j,nRet,matchLength,totalMatchLength,adrLength;
	int gyoseiCode,cityCode,choCode,azaCode,gaikuCode,chibanTableNum,found,shubetsu;
	GYOSEI_RECORD gyoseiRecord;
	CHO_RECORD choRecord;
	AZA_RECORD azaRecord;
	GAIKU_RECORD gaikuRecord;
	JUKYO_RECORD jukyoRecord;
	int codeArray[4][CODE_MAX],numCode[4],numGyoseiMatch;
	char adrBuff[STRMAX+1],*address;

	adrLength = strlen( adrStr );
	if ( adrLength == 0 || ! adrCode ) return -2;
	memset( adrCode, 0, sizeof(ADR_CODE) );

	/* R[h̕ϊ */
	if ( g_encoding ){
		int mode;
		if ( g_encoding == EUCJP ) mode = EUCJP2SJIS;
		else if ( g_encoding == UTF8 ) mode = UTF82SJIS;
		else return -2;
		nRet = gcjCharConv( mode, adrStr, adrBuff, STRMAX );
		if ( nRet < 0 ) return -2;
		address = adrBuff;
		adrLength = strlen( address );
	}
	else address = adrStr;
	
	/*  */
	totalMatchLength = 0;
	
	/* -----------------@š ---------------------- */
	/* sR[h̎擾 */
	for ( i = 0; i < 4; i++ ){ /* s{AxASAs撬̂SiK */
		nRet = GyoseiHashSearch( address + totalMatchLength, &matchLength, &shubetsu, codeArray[i], CODE_MAX );
		if ( nRet < 1 ) break;
		numCode[i] = nRet;

		/* }b`oCg̍XVP */	
		totalMatchLength += matchLength;
		if ( shubetsu == KIND_CITY ) {
			i++;
			break;
		}
	}
	if ( nRet == -1 || nRet <= -3 ) return -3;

	numGyoseiMatch = i;
	if ( numGyoseiMatch == 0 ) return 0;	/* ؃}b`Ȃ */
	
	if ( numCode[0] > 1 ) {
		/* s̓XgɂQx\BꂩǂfAŏ̂̂Ɍ */
		for ( i = 0; i < numCode[0]; i++ ){
			if ( codeArray[0][0] != codeArray[0][i] ) break;
		}
		if ( i == numCode[0] ) numCode[0] = 1;
			/* łȂꍇ́A擪}b` */
		else return -1;
	}
	
	/* ł̃x̍s悪ꍇ͏ʂ̍sƌR[h
	   `FbN */
	if ( numCode[ numGyoseiMatch - 1 ] > 1 ){
		found = FALSE;
		for ( i = 0; i < numCode[ numGyoseiMatch - 2 ]; i++ ){
			for ( j = 0; j < numCode[ numGyoseiMatch - 1 ]; j ++ ){
				if ( (codeArray[numGyoseiMatch-1][j]/1000) ==
					(codeArray[numGyoseiMatch-2][i]/1000)  ) { /* R[ḧv𒲂ׂ */
						found = TRUE;
						goto j1;
				}
			}
		}
j1:
		if ( ! found ) return 0;
			gyoseiCode = codeArray[numGyoseiMatch-1][j];
	}
	else{
		gyoseiCode = codeArray[numGyoseiMatch-1][0];
	}
		
	/* s惌R[h̎擾 */
	nRet = GyoseiRecGet( gyoseiCode, &gyoseiRecord );
	if ( nRet < 0 ) return -4;

	/* s܂Ń}b`O */
	 adrCode->codeLevel = gyoseiRecord.shubetsu;
	 switch ( gyoseiRecord.shubetsu ){
		case KIND_KEN: adrCode->cityCode = gyoseiRecord.kenCode * 1000; break;
		case KIND_SHICHO: adrCode->cityCode = gyoseiRecord.shichoCode; break;
		case KIND_GUN: adrCode->cityCode = gyoseiRecord.gunCode; break;
		case KIND_CITY: adrCode->cityCode = gyoseiRecord.cityCode; break;
		default: return -4;
	}

	/* sR[hs撬xŖ͏I */
	if ( gyoseiRecord.shubetsu < KIND_CITY || totalMatchLength == adrLength ){
		 goto ret;
	}
	
	cityCode = adrCode->cityCode;
	

	/* -----------------@厚̌ ---------------------- */
	/* 厚R[h̎擾 */
	nRet = gcjGetChoCode( cityCode, address + totalMatchLength, &matchLength, &choCode );
	if ( nRet < -1 ) return -5;

		/* Ȃ͏I */
	if ( nRet <= 0 ) goto ret;

	/* 厚܂Ń}b`O */
	adrCode->choCode = choCode;
	adrCode->codeLevel = KIND_CHO;
	
	/* }b`oCg̍XVQ */	
	totalMatchLength += matchLength;

	/* Z̍Ō܂Ō̂łΏI */
	if ( adrLength == totalMatchLength ) goto ret;
		
	/* 厚R[h̎擾 */
	nRet = ChoRecGet( cityCode, choCode, &choRecord );
	if ( nRet < 0 ) return -6;

	
	/* -----------------@ڎ̌ ---------------------- */
	/* nԊX敄e[uԍ擾 */
		/* ڎꍇ */
	if ( choRecord.azaTableNum > 0 ) {
		nRet = AzaRecSearch( choRecord.azaTableNum, 
				address + totalMatchLength, &matchLength, &azaRecord );
		if ( nRet < -1 ) return -7;

		/* ȂAڒnԈȊO͏I */
		if ( nRet <= 0 ) {
			if ( choRecord.chibanTableNum > 0 ) goto jNoAzaChomoku;
			goto ret;
		}

		/* ڎ܂Ń}b`O */
		adrCode->azaCode = azaCode = azaRecord.choazaCode & 0xffff;
		adrCode->codeLevel = KIND_AZA;
		
		/* }b`oCg̍XV3 */	
		totalMatchLength += matchLength;
		
		chibanTableNum = azaRecord.chibanTableNum;
	}
		/* ڎȂꍇ */
	else if ( choRecord.chibanTableNum > 0 ){
jNoAzaChomoku:
		chibanTableNum = choRecord.chibanTableNum;
		azaCode = 0;
	}
	else goto ret;

	/* Z̍Ō܂Ō̂łΏI */
	if ( adrLength == totalMatchLength ) goto ret;


	/* -----------------nԊX敄̌ ---------------------- */
	/* nԊX敄̌ */
	nRet = GaikuRecSearch( chibanTableNum, address + totalMatchLength,
							&matchLength, &gaikuRecord );
	if ( nRet < -1 ) return -8;

		/* Ȃ͏I */
	if ( nRet <= 0 ) goto ret;

	/* nԊX敄܂Ń}b`O */
	adrCode->gaikuCode = gaikuCode = gaikuRecord.gaikuCode;
	adrCode->codeLevel = KIND_GAIKU;

	/* }b`oCg̍XV4 */	
	totalMatchLength += matchLength;

	/* Z̍Ō܂Ō̂łΏI */
	if ( adrLength == totalMatchLength ) goto ret;

	/* -----------------}ԏZԍ̌ ---------------------- */
	/* }ԏZԍ̌ */
	nRet = JukyoRecSearch( gaikuRecord.jukyoTableNum, address + totalMatchLength,
							&matchLength, &jukyoRecord );
	if ( nRet < -1 ) return -9;

		/* Ȃ͏I */
	if ( nRet <= 0 ) goto ret;

	/* }ԏZԍ܂Ń}b`O */
	adrCode->jukyoCode = jukyoRecord.jukyoCode;
	adrCode->codeLevel = KIND_JUKYO;

	/* }b`oCg̍XV5 */	
	totalMatchLength += matchLength;

ret:
	return GetSjisCharLength( address, totalMatchLength );
}


/* VtgJIS܂񂾕̕𐔂

	str : 
	bytes : ׂoCg
	߂l
*/

static int GetSjisCharLength( char *str, int bytes )
{
	int n = 0;
	while( *str && bytes > 0 ){
		if ( IsSjisKanji( str ) ) {
			str += 2;
			bytes -= 2;
		}
		else {
			str++;
			bytes--;
		}
		n++;
	}
	return n;	
}

