/*
* [gcjchimei25k.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/


/***********************************************************************

						25000n֐

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>

#include "geocoder.h"
#include "gcjlib.h"

#define TRUE 1
#define FALSE 0

extern int g_encoding;		/* 0:SJIS 1:EUCJP 2:UTF8 */


/*---------------------------------------------------------------------

	QTOOOnf[^x[XAn̈ܓxoxȂǂԂB
	
	(in)
		chimeiStr   : n
		maxData		: chimeiDataz̍ővf
	(out)
		chimei25kData  : 25000nf[^̍\̔z
		@@@@@@@@ENULLw肵ꍇ͌ʂ̃f[^̂ݕԂB
		@@@@@@@@Ew肳ꂽnǂɊ܂ޒni[
	
	߂l
		  1ȏ  : ꂽnf[^
		  0      : w肳ꂽnDBɓo^ĂȂ
		 F	G[
		 -1  : z̍ővf܂Ŋi[AȏɃf[^B
		 -2  : ُin񂪋AT|[gĂȂR[hȂ)
		 -3ȉ : ̃G[

		
-----------------------------------------------------------------------
*/

#define CODE_MAX 10000

static int codeArray[ CODE_MAX ];

int gcjChimei25kSearch( char *chimeiStr, CHIMEI25K_DATA *chimei25kData, int maxData )
{
	char chimeiBuff[STRMAX+1],*chimei;
	CHIMEI25K_RECORD chimei25kRecord;
	int i,index,nRet,numCodes;

	if ( strlen( chimeiStr ) == 0 || ( chimei25kData  && ( maxData < 1 ) )) return -2;

	/* R[h̕ϊ */
	if ( g_encoding ){
		int mode;
		if ( g_encoding == EUCJP ) mode = EUCJP2SJIS;
		else if ( g_encoding == UTF8 ) mode = UTF82SJIS;
		else return -2;
		nRet = gcjCharConv( mode, chimeiStr, chimeiBuff, STRMAX );
		if ( nRet < 0 ) return -2;
		chimei = chimeiBuff;
	}
	else chimei = chimeiStr;
	
	/*@nbVe[u */
	nRet = Chimei25kHashSearch( chimei, codeArray, CODE_MAX );
	if ( nRet == 0 ) return 0;		/* DBɓo^ĂȂ */
	if ( nRet == -1 ) return -3;	/* DB[hĂȂ */
	if ( nRet == -3 ) return -4;	/* zeʃG[ */
	
	numCodes = nRet;
	index = 0;

	/* R[ḧܓxoxi[ */
	for ( i = 0; i < numCodes; i++ ){
		nRet = Chimei25kRecGet( codeArray[i], &chimei25kRecord );
		if ( nRet < 0 ) return -5;
		
		if ( chimei25kData ){	/*@NULL̎̓JEg邾 */
			if ( index == maxData ) return -1;

			chimei25kData[index].chimei25kCode = chimei25kRecord.chimeiCode;
			chimei25kData[index].cityCode = chimei25kRecord.cityCode;
			chimei25kData[index].kind = chimei25kRecord.chimeiKind;
		
			/* ܓxox̓~bxɕϊ */
			chimei25kData[index].latitude = (double)chimei25kRecord.latitude / 3600000;
			chimei25kData[index].longitude = (double)chimei25kRecord.longitude / 3600000;
			
			/* ̂̊i[ */
				/* R[h̕ϊ */
			if ( g_encoding ){
				int mode;
				if ( g_encoding == EUCJP ) mode = SJIS2EUCJP;
				else if ( g_encoding == UTF8 ) mode = SJIS2UTF8;
				else return -6;
		
				/* ̂̕ϊ */
				nRet = gcjCharConv( mode, chimei25kRecord.name, chimei25kData[index].name, CHIMEI25K_NAME_LEN );
				if ( nRet < 0 ) return -6;
			}
			else gcjStrcpy( chimei25kData[index].name, chimei25kRecord.name, CHIMEI25K_NAME_LEN );
		}
		
		index++;
	}
	
	return index;
}

