/*
* [gcjdb.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/***********************************************************************

	gcjDb Function : pZDB֐

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"

/*-------------------------
	萔
---------------------------
*/

#define DB_NUM_FILES 16


/*-------------------------
	ϐ
---------------------------
*/
extern int g_outFormat;
extern int g_encoding;

static int m_memoryLoaded[ DB_NUM_FILES+1 ];
static char m_dbDirPath[ STRMAX+1 ];
static char m_pathBuff[ STRMAX+1 ];

static int m_errorFuncNum;
static int m_errorNum;
static char m_errorFilePath[ STRMAX+1 ];
static char m_errorText[ STRMAX+1 ];

/*-------------------------
	֐
---------------------------
*/

/*---------------------------------------------------------------------

	ZDBۑĂfBNgݒ肷B

	(in)
		dbDirPath : ZDBt@Ci[ĂfBNg

	߂l
	      0 : I
		F	G[
			-1 : fBNg̃pXi255ȓj

-----------------------------------------------------------------------
*/


int gcjDbSetPath( char *dbDirPath )
{
	if ( strlen( dbDirPath ) > 255 ) return -1;

	gcjStrcpy( m_dbDirPath, dbDirPath, STRMAX );

	return 0;
}

/*---------------------------------------------------------------------

	ZDB̃t@CɃ[hB
	
	(in)
		dbDirPath : ZDBt@Ci[ĂfBNg
		loadLevel : [hZDB̃x
			DB_AUTO   = 0 : łڍׂȃx
			DB_GYOSEI = 1 : siASAs撬xj
			DB_CHO    = 2 : 厚
			DB_AZA    = 3 : ڎ
			DB_GAIKU  = 4 : nԁAX敄
			DB_JUKYO  = 5 : }ԁAZԍ
			
			DB_CHIMEI25K = 14 : 25000nf[^
			DB_MOJI_INDEX = 16 : CfbNX

	EloadLevelDB_CHO`DB_JUKYȌꍇAw肵xȏilƂĂ͏j
	@SẴf[^[hB
	@DB_AUTOw肷Ɨpłłڍׂȃx̃f[^[hB

	EłɃ[hĂ郌xɂĂ͉ȂB

	EX֔ԍCfbNX͒厚xȉ̃xŎIɃ[hB
	
	ȄIAgcjDbEnd()ĂяoŃJB
	
	߂l
		  1ȏ : [hłZDB̃x
	      0 : [hłf[^
		F	G[
			-1 : fBNg̃pXi255ȓj
			-2 : w肵x͌݃T|[gĂȂB
			-10.. : s惌R[h@@@@@@ɊւG[
			-20.. : s於nbVe[u@@@V
			-30.. : 厚R[h@@@@@@@@@V
			-40.. : 厚nbVe[u@@@@V
			-50.. : ڎe[u@@@@@@@@@V
			-60.. : nԊX敄e[u@@@@@@V
			-70.. : }ԏZԍe[u@@@@@@V
		   -140.. : 25000nR[h @@@@@@@V
		   -150.. : 25000nnbV @@@@@@@V
		   -160.. : CfbNX@@@@@@@@V
		
		E-10ȍ~̏ꍇAꌅڂ̃G[R[h
			-1 : mۂłȂ
			-2 : t@CI[vłȂ
			-3 : t@CID̕񂪈Ⴄ
			-4ȍ~ : t@C̃[hG[

-----------------------------------------------------------------------
*/

int gcjDbLoad( char *dbDirPath, int loadLevel )
{
	int i,nRet,loadResult,levelIsAuto,loadedLevel,level;
	char *filePath,stringFilePath[STRMAX+1];

	/* ϐ̏ */
	g_encoding = SJIS;	/* = 0 */	
	g_outFormat = 0xffffffff;

	if ( strlen( dbDirPath ) > 255 ) { nRet = -1; goto err; }
	gcjStrcpy( m_dbDirPath, dbDirPath, STRMAX );

	/* 25000nDB[hꍇ */	
	if ( loadLevel == DB_CHIMEI25K ){
		for ( i = 14; i <= 16; i ++ ){
			if( m_memoryLoaded[i] ) continue;
			filePath = gcjDbFilePath( i );
			switch( i ){
				case 14: 
						loadResult = Chimei25kRecLoad( filePath ); break;

				case 15: 
						loadResult = Chimei25kHashLoad( filePath ); break;
			}
			if ( loadResult < 0 ) {
				nRet = -10 * i + loadResult ;
				goto err;
			}
			m_memoryLoaded[ i ] = 1;
		}
		nRet = DB_CHIMEI25K;
		goto ret;
	}

	/* CfbNX[hꍇ */	
	if ( loadLevel == DB_MOJI_INDEX ){
		if( ! m_memoryLoaded[ loadLevel ] ) {
			filePath = gcjDbFilePath( loadLevel );
			loadResult = MojiIndexLoad( filePath );
			if ( loadResult < 0 ) {
				nRet = -10 * loadLevel + loadResult ;
				goto err;
			}
			m_memoryLoaded[ loadLevel ] = 1;
		}
		nRet = DB_MOJI_INDEX;
		goto ret;
	}

	/* ZDB[hꍇ */
	if ( loadLevel > DB_JUKYO || loadLevel < 0 ) { nRet = -2; goto err; }

	levelIsAuto = ( loadLevel == DB_AUTO );
	if ( levelIsAuto ) level = DB_JUKYO;
	else level = loadLevel;

	loadedLevel = 0;
	
	gcjStrcpy( stringFilePath, gcjDbFilePath( ID_STRING ), STRMAX );
	for ( i = 1; i <= DB_NUM_FILES; i++ ){
		if( m_memoryLoaded[i] ) continue;
		filePath = gcjDbFilePath( i );
		gcjStrcpy( m_errorFilePath, filePath, STRMAX );
		switch( i ){
			case 1: loadResult = GyoseiRecLoad( filePath ); break;

			case 2:	loadResult = GyoseiHashLoad( filePath ); 
					if ( loadResult >= 0 ) loadedLevel = DB_GYOSEI;
					break;

			case 3: if ( level < DB_CHO ) continue;
					loadResult = ChoRecLoad( filePath );
					if ( loadResult < 0  && levelIsAuto ) continue;
					break;

			case 4: if ( level < DB_CHO ) continue;
					loadResult = ChoHashLoad( filePath );
					if ( loadResult < 0  && levelIsAuto ) continue;
					if ( loadResult >= 0 ) loadedLevel = DB_CHO;
					break;
					
			case 5: if ( level < DB_AZA ) continue;
					loadResult = AzaRecLoad( filePath );
					if ( loadResult < 0  && levelIsAuto ) continue;
					if ( loadResult >= 0 ) loadedLevel = DB_AZA;
					break;

			case 6: if ( level < DB_GAIKU ) continue;
					loadResult = GaikuRecLoad( filePath, stringFilePath );
					if ( loadResult < 0  && levelIsAuto ) continue;
					if ( loadResult >= 0 ) loadedLevel = DB_GAIKU;
					break;

			case 7: if ( level < DB_JUKYO ) continue;
					loadResult = JukyoRecLoad( filePath, stringFilePath ); 
					if ( loadResult < 0  && levelIsAuto ) continue;
					if ( loadResult >= 0 ) loadedLevel = DB_JUKYO;
					break;
					
			case 8: continue;
			case 9: continue;
			case 10: continue;
			case 11: continue;
			case 12: continue;

			case 13: if ( level < DB_CHO ) continue;
					loadResult = PostIndexLoad( filePath ); break;
			
			case 14: continue;
			case 15: continue;
			case 16: continue;		
			
			default: nRet = -2; goto err;
		}
		if ( loadResult < 0 ) {
			nRet = -10 * i + loadResult ;
			goto err;
		}
		m_memoryLoaded[ i ] = 1;
	}
	nRet = loadedLevel;
	
ret:
	m_errorFuncNum = 0;
	m_errorNum = nRet;
	return nRet;
	
err:
	gcjDbEnd();
	goto ret;
}

/*---------------------------------------------------------------------

	ZDB\t@C̃tpX擾B
	
	(in)
		fileId : t@CIDԍ
	
	߂l
		NULLȊO FtpXiPj
		NULL     : ID̔ԍ͈͊O

@@E̊֐ĂяoOɁAgcjDbSetPath()܂gcjDbLoad()
@@@ĂяoĂ˂΂ȂȂB

@@PF̃tpX͈ꎞIȃobt@Ɋi[Ă̂ŁAKv
@@@@@ꍇ͓eĂяoŕۑĂȂ΂ȂȂB
		
-----------------------------------------------------------------------
*/

char *gcjDbFilePath( int fileId )
{
	char dbFileName[DB_NUM_FILES+1][STRMAX+1] = {
			"",						/* dummy */
			FILE_NAME_GYOSEI,		/* #1 */
			FILE_NAME_GYOSEIHASH,	/* #2 */
			FILE_NAME_CHO,			/* #3 */
			FILE_NAME_CHOHASH,		/* #4 */
			FILE_NAME_AZA,			/* #5 */
			FILE_NAME_GAIKU,		/* #6 */
			FILE_NAME_JUKYO,		/* #7 */
			FILE_NAME_MAGOBAN,		/* #8 */
			FILE_NAME_STRING,		/* #9 */
			FILE_NAME_MPOST,		/* #10 */
			FILE_NAME_VARIATION,	/* #11 */
			FILE_NAME_GYOSEI_LIST,	/* #12 */
			FILE_NAME_POST_INDEX,	/* #13 */
			FILE_NAME_CHIMEI25K,	/* #14 */
			FILE_NAME_CHIMEI25KHASH,/* #15 */
			FILE_NAME_MOJI_INDEX	/* #16 */
			};
			
	if ( fileId <= 0 || fileId > DB_NUM_FILES ) return 0;
	
	gcjStrcpy( m_pathBuff, m_dbDirPath, STRMAX );

#ifdef WIN32
	gcjStrcat( m_pathBuff, "\\" , STRMAX );
#else
	gcjStrcat( m_pathBuff, "/" , STRMAX );
#endif

	gcjStrcat( m_pathBuff, dbFileName[ fileId ] , STRMAX );
	
	return m_pathBuff;
}
	

/*---------------------------------------------------------------------

	ZDBɊւĂ̏IB
	
	EmۂJB
	
	߂l
		0 : 	I
		
-----------------------------------------------------------------------
*/

int gcjDbEnd()
{
	int i;

	for ( i = 1; i <= DB_NUM_FILES; i++ ){
		if ( m_memoryLoaded[ i ] ){
			switch( i ){
				case 1: GyoseiRecEnd(); break;
				case 2: GyoseiHashEnd(); break;
				case 3: ChoRecEnd(); break;
				case 4: ChoHashEnd(); break;
				case 5: AzaRecEnd(); break;
				case 6: GaikuRecEnd(); break;
				case 7: JukyoRecEnd(); break;
				case 13: PostIndexEnd(); break;
				case 14: Chimei25kRecEnd(); break;
				case 15: Chimei25kHashEnd(); break;
			}
			m_memoryLoaded[ i ] = 0;
		}
	}
	
	m_errorFuncNum = 2;
	m_errorNum = 0;
	return 0;
}


/*---------------------------------------------------------------------

	ZDB֐ɊւẴG[eԂB
	
	EG[̓éÅ֐ĂԒȌɊւĂ̂́B
	
	߂l
		0 : 	I
		
-----------------------------------------------------------------------
*/

char *gcjDbErrorText()
{
	int errorNum,err;
	char errorText[][10][128] = {
		/* gcjDbLoad() */
		{ "No error.", 
		  "DB path exceeds 255 chars.",		/*1*/
		  "Specified level not supported.",
		  "Memory allocation error.",		/*3*/
		  "File open error.",
		  "File ID string does not match.",	/*5*/
		  "File read error.",
		  "",								/*7*/
		  "",
		  ""								/*9*/
		}
	};

	if ( m_errorNum == 0 ) {
		gcjStrcpy( m_errorText, "No error.", STRMAX );
		return 0;
	}
	
	if ( m_errorFuncNum == 0 ){
		errorNum = - m_errorNum;
		if ( errorNum <= 2 ) gcjStrcpy( m_errorText, errorText[0][errorNum], STRMAX );
		else if ( errorNum < 10 ) goto unknown;
		else {
			if ( errorNum < 20 ) {
				gcjStrcpy( m_errorText, "GyoseiKuiki record file: ", STRMAX );
				err = errorNum - 10;
			}
			else if ( errorNum < 30 ) {
				gcjStrcpy( m_errorText, "GyoseiKuiki hash table file: ", STRMAX );
				err = errorNum - 20;
			}
			else if ( errorNum < 40 ) {
				gcjStrcpy( m_errorText, "ChoOaza record file: ", STRMAX );
				err = errorNum - 30;
			}
			else if ( errorNum < 50 ) {
				gcjStrcpy( m_errorText, "ChoOaza hash table file: ", STRMAX );
				err = errorNum - 40;
			}
			else if ( errorNum < 60 ) {
				gcjStrcpy( m_errorText, "Chomoku aza record file: ", STRMAX );
				err = errorNum - 50;
			}
			else if ( errorNum < 70 ) {
				gcjStrcpy( m_errorText, "Gaiku record file: ", STRMAX );
				err = errorNum - 60;
			}
			else if ( errorNum < 80 ) {
				gcjStrcpy( m_errorText, "Jukyo record file: ", STRMAX );
				err = errorNum - 70;
			}
			else  goto unknown;
			
			if ( err > 4 ) err = 4;
			gcjStrcat( m_errorText, errorText[0][err + 2] , STRMAX );
			gcjStrcat( m_errorText, m_errorFilePath, STRMAX );
		}
	}
	else goto unknown;

ret:
	return m_errorText;

unknown:
	 gcjStrcpy( m_errorText, "Unknown error." , STRMAX );
	 goto ret;
}

