/*
* [gcjget.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/***********************************************************************
						WIR[fBO֐
------------------------------------------------------------------------

	gcjGet Function : X̑Ȃǂ擾B

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>

#include "geocoder.h"
#include "gcjlib.h"



/*---------------------------------------------------------------------

	w肵Zx̃R[h擾	

	(in)
	adrCode : R[h擾ZR[h
				ǂ̏Zx̃R[h擾邩codeLeveltB[h
				w肷B 
			Ewł郌x
				TF厚̃R[h
				UFڎ̃R[h
				VFnԊX敄̃R[h
				WF}ԏZԍ̃R[h
				݂̂łB
			EŎw肵x̊eR[hw肵ĂȂƃG[
			@ȂB
			E̊֐ĂԑOɏZDBɃ[hĂȂ΂ȂȂB
			
	߂l
			0 ȏ : R[h
			 : G[
				-1  : w肳ꂽcodeLevelʂ̃R[hԍ
				-2  : w肳ꂽcodeLevel̓T|[gĂȂB
				-3  : KvȏZDB[hĂȂ
				-4  : R[hԍȔ͈͂łȂ
				-5  : ̑̃G[
				
-----------------------------------------------------------------------
*/

int gcjGetNumAdrRecords( ADR_CODE *adrCode )
{
	int nret,codeLevel,cityCode,choCode,azaCode,gaikuCode;
	
	codeLevel = adrCode->codeLevel;
	if ( codeLevel < 5 || codeLevel > 8 ) return -2;

	/* 厚R[h */	
	cityCode = adrCode->cityCode;
	if ( cityCode < 1000 || cityCode > 47999 ) return -1;

	if ( codeLevel == KIND_CHO ) {
		nret = ChoRecNumRecords( cityCode );
		if ( nret >= 0 ) return nret;
		if ( nret == -1 ) return -3;
		if ( nret == -2 ) return -4;
		else return -5;
	}

	/* ڎR[h */	
	choCode = adrCode->choCode;
	if ( choCode == 0 ) return -1;

	if ( codeLevel == KIND_AZA ) {	
		nret = AzaRecNumRecords( cityCode, choCode );
		if ( nret >= 0 ) return nret;
		if ( nret == -1 ) return -3;
		if ( nret == -2 ) return -4;
		else return -5;
	}
	
	/* nԊX敄R[h */	
	azaCode = adrCode->azaCode;
	if ( azaCode < 0 ) return -1;

	if ( codeLevel == KIND_GAIKU ) {	
		nret = GaikuRecNumRecords( cityCode, choCode, azaCode );
		if ( nret >= 0 ) return nret;
		if ( nret == -101 ) return -3;
		else return -5;
	}

	/* }ԏZԍR[h */	
	gaikuCode = adrCode->gaikuCode;
	if ( gaikuCode <= 0 ) return -1;

	if ( codeLevel == KIND_JUKYO ) {	
		nret = JukyoRecNumRecords( cityCode, choCode, azaCode, gaikuCode );
		if ( nret >= 0 ) return nret;
		if ( nret == -101 ) return -3;
		else return -5;
	}
	
	return -2;
}


/*---------------------------------------------------------------------

	w肵Zx̃R[h̃Xg擾B

	(in)
		adrCode : R[hXg擾ZR[h
				   ǂ̏Zx̃R[hXg擾邩codeLevel
				   tB[hŎw肷B gcjGetNumAdrRecords()QƁB
		recordMax : R[hԍi[z̗vf
	(out)
		codeArray : R[hԍi[z

			
	߂l
			0 ȏ : i[R[h
			 : G[
				-1  : w肳ꂽcodeLevelʂ̃R[hԍ
				-2  : w肳ꂽcodeLevel̓T|[gĂȂB
				-3  : KvȏZDB[hĂȂ
				-4  : R[hԍȔ͈͂łȂ
				-5  : ̑̃G[
				
-----------------------------------------------------------------------
*/

int gcjGetAdrRecordList( ADR_CODE *adrCode, int *codeArray,
									                  int recordMax )
{
	int i,nret,codeLevel,cityCode,choCode,azaCode,gaikuCode;
	
	codeLevel = adrCode->codeLevel;
	if ( codeLevel < 5 || codeLevel > 8 ) return -2;

	/* 厚R[h */	
	cityCode = adrCode->cityCode;
	if ( cityCode < 1000 || cityCode > 47999 ) return -1;

	if ( codeLevel == KIND_CHO ) {
		nret = ChoRecNumRecords( cityCode );
		if ( nret > 0 ) goto sameAsRecordNum;
		if ( nret == 0 ) return nret;
		if ( nret == -1 ) return -3;
		if ( nret == -2 ) return -4;
		else return -5;
	}

	/* ڎR[h */	
	choCode = adrCode->choCode;
	if ( choCode == 0 ) return -1;

	if ( codeLevel == KIND_AZA ) {	
		nret = AzaRecNumRecords( cityCode, choCode );
		if ( nret > 0 ) goto sameAsRecordNum;
		if ( nret == 0 ) return nret;
		if ( nret == -1 ) return -3;
		if ( nret == -2 ) return -4;
		else return -5;
	}
	
	/* nԊX敄R[h */	
	azaCode = adrCode->azaCode;
	if ( azaCode < 0 ) return -1;

	if ( codeLevel == KIND_GAIKU ) {	
		nret = GaikuRecGetList( cityCode, choCode, azaCode, codeArray, recordMax );
		if ( nret >= 0 ) return nret;
		if ( nret == -101 ) return -3;
		else return -5;
	}

	/* }ԏZԍR[h */	
	gaikuCode = adrCode->gaikuCode;
	if ( gaikuCode <= 0 ) return -1;

	if ( codeLevel == KIND_JUKYO ) {	
		nret = JukyoRecGetList( cityCode, choCode, azaCode, gaikuCode, codeArray,
																recordMax );
		if ( nret >= 0 ) return nret;
		if ( nret == -101 ) return -3;
		else return -5;
	}
	
	return -2;

sameAsRecordNum:
	/* R[hԍƃR[hԍꍇ */
	for ( i = 1; i <= nret; i++ ){
		if ( i > recordMax ) break;
		codeArray[ i - 1 ] = i;
	}
	return i-1;
}


/*---------------------------------------------------------------------

	w肵Zx̃R[h擾B

	(in)
		adrCode : R[h擾ZR[h
				  ǂ̏Zx̃R[h擾邩codeLevel tB[hŎw肷B 
				  gcjGetNumAdrRecords()QƁB̊֐̓x͂PȏB
		recordBytes : R[hobt@̃oCg
	(out)
		record  : 擾R[hi[obt@

	߂l
			0  : I
			 : G[
				-1  : w肳ꂽcodeLevelʂ̃R[hԍ
				-2  : w肳ꂽcodeLevel̓T|[gĂȂB
				-3  : KvȏZDB[hĂȂ
				-4  : R[hԍȔ͈͂łȂ
				-5  : obt@̃oCgȂ
				-6  : ̑̃G[
				
-----------------------------------------------------------------------
*/

int gcjGetAdrRecord( ADR_CODE *adrCode, void* record, int recordBytes )
{
	int nret,codeLevel,cityCode,choCode,azaCode,gaikuCode,jukyoCode,jukyoHyoji;
	
	codeLevel = adrCode->codeLevel;
	if ( codeLevel < 1 || codeLevel > 8 ) return -2;

	/* s惌R[h */	
	cityCode = adrCode->cityCode;
	if ( cityCode < 1000 || cityCode > 47999 ) return -1;

	if ( codeLevel < KIND_CHO ) {
		if ( recordBytes < sizeof( GYOSEI_RECORD ) ) return -5;
		nret = GyoseiRecGet( cityCode, record );
		if ( nret == 0 ) return 0;
		if ( nret == -1 ) return -3;
		if ( nret == -2 ) return -4;
		else return -6;
	}

	/* 厚R[h */	
	choCode = adrCode->choCode;
	if ( choCode == 0 ) return -1;

	if ( codeLevel == KIND_CHO ) {
		if ( recordBytes < sizeof( CHO_RECORD ) ) return -5;
		nret = ChoRecGet( cityCode, choCode, record );
		if ( nret == 0 ) return 0;
		if ( nret == -1 ) return -3;
		if ( nret == -2 ) return -4;
		else return -6;
	}

	/* ڎR[h */	
	azaCode = adrCode->azaCode;
	if ( azaCode < 0 ) return -1;

	if ( codeLevel == KIND_AZA ) {	
		if ( recordBytes < sizeof( AZA_RECORD ) ) return -5;
		nret = AzaRecGet( cityCode, choCode, azaCode, record );
		if ( nret == 0 ) return 0;
		if ( nret == -1 ) return -3;
		if ( nret == -2 ) return -4;
		else return -6;
	}
	
	/* nԊX敄R[h */	
	gaikuCode = adrCode->gaikuCode;
	if ( gaikuCode <= 0 ) return -1;

	if ( codeLevel == KIND_GAIKU ) {	
		if ( recordBytes < sizeof( GAIKU_RECORD ) ) return -5;
		nret = GaikuRecGet( cityCode, choCode, azaCode, gaikuCode, record, &jukyoHyoji );
		if ( nret == 0 ) return 0;
		if ( nret == -101 ) return -3;
		else return -6;
	}

	/* }ԏZԍR[h */	
	jukyoCode = adrCode->jukyoCode;
	if ( jukyoCode <= 0 ) return -1;

	if ( codeLevel == KIND_JUKYO ) {	
		nret = JukyoRecGet( cityCode, choCode, azaCode, gaikuCode, jukyoCode, record );
		if ( nret == 0 ) return 0;
		if ( nret == -101 ) return -3;
		else return -6;
	}
	
	return -2;

}
