/*
* [gcjgetazacode.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/***********************************************************************

	gcjGetAzaCode: ڎR[h擾B

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"

/*---------------------------------------------------------------------

	Z̐擪ɂ钚ڎAڎ̃R[h
	擾B
	
	(in)
		cityCode   : s撬R[hiTj
		choCode    : 厚R[h
		str        : Z
	(out)
		matchLength : }b`O񕔕̃oCg
		azaCode     : ڎ̃R[h
		  
	߂l
			 1 : 
			 0 : Ȃ
		F G[
			-1 : ̒O
			-2 : 厚R[h擾łȂ

	Ew肳ꂽ厚̒ڎ̂ŁAZ̐擪ɍv̂TB

	Eږ͏Z̐擪matchLength̃oCg
	@łB
	@̐̕ȕ\LAzaRecGet()֐ɂm鎖łB

	E̊֐ĂяoOgcjDbLoad()֐ŏZDBɃ[h
	@ĂB

-----------------------------------------------------------------------
*/

int gcjGetAzaCode( int cityCode, int choCode, char *str, 
										int *matchLength, int *azaCode )
{
	int nRet,azaTableNum;
	CHO_RECORD choRecord;
	AZA_RECORD azaRecord;

	if ( ! strlen(str) ) { nRet = -1; goto ret; }

	nRet = ChoRecGet( cityCode, choCode, &choRecord );
	if ( nRet < 0 ) { 
		nRet = -2; goto ret;
	 }

	azaTableNum = choRecord.azaTableNum;
	if ( ! azaTableNum ) { nRet = 0; goto ret; }
	
	nRet = AzaRecSearch( azaTableNum, str, matchLength, &azaRecord );
	if ( nRet == 1 ) {
		*azaCode = azaRecord.choazaCode & 0xffff;
		return 1;
	}
	
	nRet = 0;
ret:
	*matchLength = *azaCode = 0;
	return nRet;
}
