/*
* [gcjgetchocode.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/***********************************************************************

	gcjGetChoCode: 厚R[h擾B

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"

/*---------------------------------------------------------------------

	Z̐擪ɂ钬厚A厚̃R[h
	擾B
	
	(in)
		cityCode   : s撬R[hiTj
		str        : Z
	(out)
		matchLength : }b`O񕔕̃oCg
		choCode     : 厚̃R[h
		  
	߂l
			 1 : 
			 0 : Ȃ
		F G[
			-1 : ZDBinbVe[ujɃ[hĂȂ
			-2 : ̒O
			-3 : s撬R[h͈̔̓G[
			-4 : w肳ꂽs撬̃nbVe[u
			-5 : nbVe[u̎s撬R[hȂ
			-6 : z̊mۃG[

	Ew肳ꂽs撬̒厚̂ŁAZ̐擪ɍv̂TB

	E厚͏Z̐擪matchLength̃oCg
	@łB
	@̐̕ȕ\LChoRecGet()֐ɂm鎖łB

	E̊֐ĂяoOgcjDbLoad()֐ŏZDBɃ[h
	@ĂB

	EcityCodes̏ꍇ̈
	@@厚R[hĂȂꍇ́AmatchLenghtOA
	@@choCode͂Pi厚jԂB

	E"厚"A""̏
	@@厚͖ɍ폜BłȂArɑ厚Ă
	@@ꍇiFÉs΋L厚ԁĵŁB
	@@ȂꍇA擪""̕邩ׂΎ
	@@ČBin̈ꕔƂ""܂܂ĂꍇBj
-----------------------------------------------------------------------
*/

int gcjGetChoCode( int cityCode, char *str, int *matchLength, int *choCode )
{
	int nRet,n;
	GYOSEI_RECORD gyoseiRec;
	char *p,strBuff[STRMAX+1],*pStr;

	/* "厚"̍폜 */
	p = strstr( str, "厚" );
	if ( p ){
		if ( p == str ) pStr = str + 4;
		else {
			strncpy( strBuff, str, p - str );
			*( strBuff + ( p -str) ) = '\0';
			gcjStrcat( strBuff, p + 4, STRMAX );
			pStr = strBuff;
		}
	}
	else  pStr = str;
	
	/*  */
	nRet = ChoHashSearch( cityCode, pStr, matchLength, choCode );
	if ( nRet == 1 ){
		if ( pStr != str ) *matchLength += 4;
		return 1;
	}
	
	/* ȂꍇA擪""ΎčČ */
	if ( nRet == 0 ) {
		p = strstr( str, "" );
		if ( p == str ) {
			nRet = ChoHashSearch( cityCode, str + 2, matchLength, choCode );
			if ( nRet == 1 ) *matchLength += 2;
		}
	}


	/* nbVe[uȂꍇAs惌R[h݂΁A
	   ͋s撬Ȃ̂ŁAchoCode͂PԂB
	*/
	if ( nRet == -4 ){
		n = GyoseiRecGet( cityCode, &gyoseiRec );
		if ( n == 0 ){
			*matchLength = 0;
			*choCode = 1;
			return 1;
		}
	}
			
	return nRet;
}
