/*
* [gcjgetgyoseicode.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/***********************************************************************

	gcjGetGyoseiCode: sR[h擾B

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"

/*-------------------------
	ϐ
---------------------------
*/

/*---------------------------------------------------------------------

	Z̍sR[h擾B
	
	(in)
		str : Z
		maxArray : codeArray[]̍ővf
	(out)
		matchLength : }b`O񕔕̃oCg
		codeArray : sR[h

	߂l
		 : sR[h̐
		   0 : w肳ꂽ̐擪ɊYs͌Ȃ
		 F	G[
			-1 : nbVe[uɃ[hĂȂ
			-2 : ̒O
			-3 : nbVe[ũR[hԍs惌R[h擾łȂ

	E^ꂽẐAs{AxASAs撬T
	@Amłłs̃R[hԂB

	E̊֐ĂяoOgcjDbLoad()֐ŏZDBɃ[h
	@ĂB
-----------------------------------------------------------------------
*/

int gcjGetGyoseiCode( char *str, int *matchLength, int codeArray[], int maxArray )
{
	int foundCode[4][10],numFound[4],matchBytes[4];
	char *pStr;
	int i,j,k,len,numParts,imax,jmax,kenCode,numMatch,shubetsu;

	pStr = str;
	for ( i = 0; i < 4; i++ ){
		if ( ! strlen( pStr ) ) break;
		/* snbVe[u */
		numFound[i] = GyoseiHashSearch( pStr, &matchBytes[i], &shubetsu, foundCode[i], 10 );
		if ( numFound[i] < 0 ) return numFound[i];
		if ( numFound[i] == 0 ) break;
		len = matchBytes[i];
		if ( len <= 0 ) return -100;
		pStr += len;
	}
	if ( i == 0 ) return 0;
	numParts = i;
	
	/* }b`ÔPڂ̏ꍇ͂̂܂ܕԂ */
	if ( numParts == 1 ){	
		imax = numFound[0];
		if ( imax > maxArray ) imax = maxArray;
		for ( i = 0; i < imax; i++ ) codeArray[i] = foundCode[0][i];
		*matchLength = matchBytes[0];
		return imax;
	}
	
	/* ڂ̏ꍇ́Aԉ̍ڂŏʂ̍ڂƌR[hv̂Ԃ */
	/* ̕Ԃ͑SĂ̏ꍇsȂAp͂قǖȂ */
	/* ̒iKŌȂƂȂŁAʂ̕`FbN
		@@Av鍀ڐŊĂƁAꕔԈĂĂ}b`OłB */

	numMatch = 0;
	for ( i = 0; i < numFound[ numParts-1 ]; i++ ){
		kenCode = foundCode[ numParts-1 ][i] / 1000;

		jmax = numFound[ numParts-2 ];
		for( j = 0; j < jmax ; j++ ){
			if ( ( foundCode[ numParts-2][j] / 1000 ) == kenCode ){
				codeArray[ numMatch++ ] = foundCode[ numParts-1 ][i];
				if ( numMatch == maxArray ) break;
			}
		}
	}
	
	/* }b`͍ڂɂčv */
	len = 0;
	for ( k = 0; k < numParts; k++ ) len += matchBytes[ k ];
	*matchLength = len;
	
	return numMatch;
}

