/*
* [gyoseirec.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/***********************************************************************

	GyoseiRec Function : s惌R[h֐

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"

/*-------------------------
	ϐ
---------------------------
*/

	/* s惌R[ht@C */
static GYOSEI_HEADER m_gyoseiHeader;
static int m_gyoseiRecordNum[ GYOSEI_MAX ];
static GYOSEI_RECORD *m_aryRecord;

static int m_numRecords;

/*---------------------------------------------------------------------

	s惌R[ht@C̓eɊi[B
	
	(in)
		fileName : s惌R[ht@C̖
	
	E͂̊֐ŊmۂB
	ȄIAGyoseiRecEnd()ĂяoŃJB
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : mۂłȂ
			-2 : t@CI[vłȂ
			-3 : t@CID̕񂪈Ⴄ
			-4ȍ~ : t@C̃[hG[
			
-----------------------------------------------------------------------
*/

int GyoseiRecLoad( char *fileName )
{
	FILE *fpRec;
	int n,nRet;
	
	fpRec = fopen( fileName, "rb" );
	if ( fpRec == NULL ) return -2;
	
	/* wb_[ */
	n = fread( &m_gyoseiHeader, sizeof( m_gyoseiHeader ), 1, fpRec );
	if ( n != 1 ) { nRet = -4; goto err; }

	if ( strcmp( m_gyoseiHeader.fileId, FILE_ID_GYOSEI ) ) { nRet = -3; goto err; }
	m_numRecords = m_gyoseiHeader.numRecords;
	
	/* R[hԍe[u */
	n = fread( m_gyoseiRecordNum, sizeof( m_gyoseiRecordNum ), 1, fpRec);
	if ( n != 1 ){ nRet = -5; goto err; }

	/* R[h{ */
	m_aryRecord = (GYOSEI_RECORD*) malloc( sizeof(GYOSEI_RECORD) * m_numRecords );
	if ( ! m_aryRecord ){ nRet = -1; goto err; }

	n = fread( m_aryRecord, sizeof(GYOSEI_RECORD), m_numRecords, fpRec );
	if ( n != m_numRecords ) { nRet = -6; goto err; }
	
	fclose( fpRec );
	return m_numRecords;

err:
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	fclose( fpRec );
	return nRet;
}


/*---------------------------------------------------------------------

	s惌R[h̏Is
	
	EmۂJB
	
	߂l
		0 : 	I
		
-----------------------------------------------------------------------
*/

int GyoseiRecEnd()
{
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	
	return 0;
}


/*---------------------------------------------------------------------

	s惌R[h擾B
	
	(in)
		gyoseiCode : sR[hiTj

	(out)
		gyoseiRecord : s惌R[h
		
	߂l
		  0 : I
		F	G[
			-1 : s惌R[hɃ[hĂȂ
			-2 : sR[h͈̔̓G[
			-3 : R[hԍG[
			-4 : w肳ꂽsR[hɂ̓R[h
			
-----------------------------------------------------------------------
*/

int GyoseiRecGet( int gyoseiCode , GYOSEI_RECORD *gyoseiRecord )
{
	int recordNum;
	
	if ( ! m_aryRecord ) return -1;
	
	if ( gyoseiCode < 1000 || gyoseiCode >= GYOSEI_MAX ) return -2;
	
	recordNum = m_gyoseiRecordNum[ gyoseiCode ];
	if ( recordNum > m_numRecords ) return -3;

	if ( recordNum == 0 ) return -4;
	
	memcpy( gyoseiRecord, &m_aryRecord[ recordNum ], sizeof( GYOSEI_RECORD ));

	return 0;	
}

