/*
* [jukyorec.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/* Todo : nԂ̌oCiT[`ɂB
		Fnԕ񃌃R[hnԂƋpɂB
*/


/***********************************************************************

	gcjJukyo Function : }ԏZԍR[h֐

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"


/*-------------------------
	ϐ
---------------------------
*/

	/* nԊX敄R[ht@C */
static JUKYO_HEADER 		m_jukyoHeader;
static JUKYO_TABLE_LIST		*m_jukyoTableList;
static JUKYO_RECORD 		*m_aryRecord;

static int m_numTables;
static int m_numTotalRecords;

	/* nԕt@C */

static STRING_HEADER m_stringHeader;
static STR_RECORD *m_stringRecord;
static int m_stringNumRecords;

/*-------------------------
	֐
---------------------------
*/
int GetJukyoNum( char *str, int *matchLength );
int GetJukyoStr( int chibanStrNum, char *jukyoStr, int strMax );


/*---------------------------------------------------------------------

	}ԏZԍR[ht@C̓eɊi[B
	
	(in)
		recordFileName : }ԏZԍR[ht@C̖
		stringFileName : nԕ񃌃R[ht@C̖
	
	Ê̓tpXŎw
	E͂̊֐ŊmۂB
	ȄIAJukyoRecEnd()ĂяoŃJB
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : mۂłȂ
			-2 : t@CI[vłȂ
			-3 : t@CID̕񂪈Ⴄ
			-4ȍ~ : t@C̃[hG[
			
-----------------------------------------------------------------------
*/

int JukyoRecLoad( char *recordFileName, char *stringFileName )
{
	FILE *fpRec,*fpStr;
	int n,nRet;

	fpRec = fpStr = NULL;
	
	if ( m_jukyoTableList ) return m_numTotalRecords;	/*@łɃ[hς */
		
	fpRec = fopen( recordFileName, "rb" );
	if ( fpRec == NULL ) return -2;
	
	/* Zԍt@C */
		/* wb_[ */
	n = fread( &m_jukyoHeader, sizeof( m_jukyoHeader ), 1, fpRec );
	if ( n != 1 ) { nRet = -4; goto err; }

	if ( strcmp( m_jukyoHeader.fileId, FILE_ID_JUKYO ) ) { nRet = -3; goto err; }

	m_numTables = m_jukyoHeader.numTables;
	m_numTotalRecords = m_jukyoHeader.numTotalRecords;
	
		/* e[uXg */
	m_jukyoTableList = (JUKYO_TABLE_LIST*) malloc( sizeof(JUKYO_TABLE_LIST) * m_numTables );
	if ( ! m_jukyoTableList ){ nRet = -1; goto err; }
	n = fread( m_jukyoTableList, sizeof( JUKYO_TABLE_LIST ), m_numTables, fpRec);
	if ( n != m_numTables ){ nRet = -5; goto err; }

		/* R[h{ */
	m_aryRecord = (JUKYO_RECORD*) malloc( sizeof(JUKYO_RECORD) * m_numTotalRecords );
	if ( ! m_aryRecord ){ nRet = -1; goto err; }

	n = fread( m_aryRecord, sizeof(JUKYO_RECORD), m_numTotalRecords, fpRec );
	if ( n != m_numTotalRecords ) { nRet = -6; goto err; }
	
	/* nԕt@C */
	fpStr = fopen( stringFileName, "rb" );
	if ( fpStr != NULL ) {
			/*@wb_[ */
		n = fread( &m_stringHeader, sizeof( m_stringHeader ), 1, fpStr );
		if ( n != 1 ) { nRet = -8; goto err; }

		if ( strcmp( m_stringHeader.fileId, FILE_ID_STRING ) ) { nRet = -9; goto err; }
	
		m_stringNumRecords = m_stringHeader.numRecords;

			/*@R[h */
		m_stringRecord = (STR_RECORD*) malloc( sizeof(STR_RECORD) * m_stringNumRecords );
		if ( ! m_stringRecord ){ nRet = -10; goto err; }
	
		n = fread( m_stringRecord, sizeof(STR_RECORD), m_stringNumRecords, fpStr );
		if ( n != m_stringNumRecords ) { nRet = -11; goto err; }
	}
	
	if ( fpRec ) fclose( fpRec );
	if ( fpStr ) fclose( fpStr );
	
	return m_numTotalRecords;

err:
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	if ( m_jukyoTableList ) {
		free( m_jukyoTableList );
		m_jukyoTableList = NULL;
	}

	if ( m_stringRecord ) {
		free( m_stringRecord );
		m_stringRecord = NULL;
	}
	
	if ( fpRec ) fclose( fpRec );
	if ( fpStr ) fclose( fpStr );

	return nRet;
}



/*---------------------------------------------------------------------

	ɂ}ԏZԍR[h̓et@CɏށB
	
	(in)
		fileName : }ԏZԍR[ht@C̖
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : t@CI[vłȂ
			-2ȍ~ : t@C̃CgG[
			
-----------------------------------------------------------------------
*/

int JukyoRecSave( char *fileName )
{
	FILE *fpRec;
	int n,nRet;
	
	fpRec = fopen( fileName, "wb" );
	if ( fpRec == NULL ) return -1;
	
	/* wb_[ */
	n = fwrite( &m_jukyoHeader, sizeof( m_jukyoHeader ), 1, fpRec );
	if ( n != 1 ) { nRet = -2; goto err; }

	/* e[uXg */
	n = fwrite( m_jukyoTableList, sizeof( JUKYO_TABLE_LIST ), m_numTables, fpRec);
	if ( n != m_numTables ){ nRet = -3; goto err; }

	/* R[h{ */
	n = fwrite( m_aryRecord, sizeof(JUKYO_RECORD), m_numTotalRecords, fpRec );
	if ( n != m_numTotalRecords ) { nRet = -4; goto err; }
	
	fclose( fpRec );
	return m_numTotalRecords;

err:
	fclose( fpRec );
	return nRet;
}


/*---------------------------------------------------------------------

	}ԏZԍR[h̏Is
	
	EmۂJB
	
	߂l
		0 : 	I
		
-----------------------------------------------------------------------
*/

int JukyoRecEnd()
{
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	if ( m_jukyoTableList ) {
		free( m_jukyoTableList );
		m_jukyoTableList = NULL;
	}
	if ( m_stringRecord ) {
		free( m_stringRecord );
		m_stringRecord = NULL;
	}
	
	return 0;
}

/*---------------------------------------------------------------------

	w肵s撬A厚AڎAnԊX敄
	}ԏZԍR[h擾B
	
	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h(0)
		gaikuCode: nԊX敄R[h
		
	߂l
		0ȏ : }ԏZԍR[h
		F	G[
			-100ԑ : nԊX敄e[uԍ̎擾G[
			           GetJukyoTableNum()Q
			
-----------------------------------------------------------------------
*/

int JukyoRecNumRecords( int cityCode, int choCode, int azaCode,
													int gaikuCode )
{
	int tableNum;
	
	tableNum = GetJukyoTableNum( cityCode, choCode, azaCode, gaikuCode );
	if ( tableNum < 0 ) return tableNum;
		
	return m_jukyoTableList[ tableNum ].numRecords & 0xffff;
}

/*---------------------------------------------------------------------

	}ԏZԍR[ḧꗗi}ԏZԍR[h̃Xgj擾B

	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h(0)
		gaikuCode : nԊX敄R[h
		recordMax : R[hԍi[z̗vf
	(out)
		codeArray : R[hԍi[z

	߂l
		0ȏ : R[h
		F	G[
			-100ԑ : nԊX敄e[uԍ̎擾G[
			           GetGaikuTableNum()Q
-----------------------------------------------------------------------
*/

int JukyoRecGetList( int cityCode, int choCode, int azaCode, int gaikuCode,
								int *codeArray, int recordMax )
{
	JUKYO_RECORD *pRecord;
	int i,tableNum,numRecords;
	
	tableNum = GetJukyoTableNum( cityCode, choCode, azaCode, gaikuCode );
	if ( tableNum < 0 ) return tableNum;
	if ( tableNum == 0 ) return 0;

	numRecords = m_jukyoTableList[ tableNum ].numRecords & 0xffff;
	pRecord = m_aryRecord + m_jukyoTableList[ tableNum ].startRecNum;

	for ( i = 0; i < numRecords; i++ ){
		if ( i == recordMax ) break;
		codeArray[ i ] = pRecord->jukyoCode;
		pRecord++;
	}
	
	return i;
}


/*---------------------------------------------------------------------

	}ԏZԍR[h擾B

	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h(0)
		gaikuCode: nԊX敄R[h
		jukyoCode: }ԏZԍR[h

	(out)
		jukyoRecord : 擾}ԏZԍR[h

	߂l
		0 : 	I

		F	G[
			-1 : w肳ꂽ}ԏZԍe[uɖ
			-2 : jukyoRecordNULL|C^
			-100ԑ : }ԏZԍe[uԍ̎擾G[
			           GetJukyoTableNum()Q
-----------------------------------------------------------------------
*/

int JukyoRecGet( int cityCode, int choCode, int azaCode,
				int gaikuCode, int jukyoCode, JUKYO_RECORD *jukyoRecord )
{
	JUKYO_RECORD *pRecord;
	int i,tableNum,numRecords;
	
	tableNum = GetJukyoTableNum( cityCode, choCode, azaCode, gaikuCode );
	if ( tableNum < 0 ) return tableNum;

	numRecords = m_jukyoTableList[ tableNum ].numRecords & 0xffff;
	pRecord = m_aryRecord + m_jukyoTableList[ tableNum ].startRecNum;

	for ( i = 0; i < numRecords; i++ ){
		if ( jukyoCode == pRecord->jukyoCode ) break;
		pRecord++;
	}

	if ( i < numRecords ){
		if ( jukyoRecord ){
			memcpy( jukyoRecord, pRecord, sizeof( JUKYO_RECORD ) );
			return 0;
		}
		else return -1;
	}
	else return -1;
}


/*---------------------------------------------------------------------

	XZԍR[hݒ肷B
	
	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h(0)
		gaikuCode: nԊX敄R[h
		jukyoCode: }ԏZԍR[h
		jukyoRecord : ݒ肷}ԏZԍR[h
		
	߂l
		0 : 	I
		F	G[
			-1 : w肳ꂽ}ԏZԍe[uɖ
			-100ԑ : }ԏZԍe[uԍ̎擾G[
			           GetJukyoTableNum()Q

	E̊֐́Ałɂ郌R[ĥłAVK̃R[h
	@쐬łȂB
	E̊֐̓ɂ郌R[hύX邾łB
	@ۂɃt@CύXɂ́AJukyoRecSave()sB
			
-----------------------------------------------------------------------
*/

int JukyoRecPut( int cityCode, int choCode, int azaCode,
				 int gaikuCode, int jukyoCode, JUKYO_RECORD *jukyoRecord )
{
	JUKYO_RECORD *pRecord;
	int i,tableNum,numRecords;
	
	tableNum = GetJukyoTableNum( cityCode, choCode, azaCode, gaikuCode );
	if ( tableNum < 0 ) return tableNum;

	numRecords = m_jukyoTableList[ tableNum ].numRecords & 0xffff;
	pRecord = m_aryRecord + m_jukyoTableList[ tableNum ].startRecNum;

	for ( i = 0; i < numRecords; i++ ){
		if ( jukyoCode == pRecord->jukyoCode ) break;
		pRecord++;
	}

	if ( i < numRecords ){
		memcpy( pRecord, jukyoRecord, sizeof( JUKYO_RECORD ) );
		return 0;
	}
	else return -1;
}


/*---------------------------------------------------------------------

	Z̐擪ɂ}ԏZԍA}ԏZԍ̃R[h
	ԂB
	
	(in)
		jukyoTableNum : }ԏZԍe[uԍ
		str        : Z
	(out)
		matchLength : }b`O񕔕̃oCg
		jukyoReocrd : }ԏZԍ̃R[h
		  
	߂l
			 1 : 
			 0 : Ȃ
			 -1: }ԏZԍR[hɃ[hĂȂ
			 -2: e[uԍG[


	EoCiT[`B
		
-----------------------------------------------------------------------
*/
int JukyoRecSearch( int jukyoTableNum, char *str, 
							int *matchLength, JUKYO_RECORD *jukyoRecord )
{
	int numRecords,i,jukyoNum,gCode,nRet;
	JUKYO_RECORD *pRecord;
	char jukyoStr[STRMAX+1];

	if ( ! m_aryRecord ) return -1;
	if ( jukyoTableNum >= m_numTables ) return -2;
	
	pRecord = m_aryRecord + m_jukyoTableList[ jukyoTableNum ].startRecNum;
	numRecords = m_jukyoTableList[ jukyoTableNum ].numRecords & 0xffff;

	jukyoNum = GetJukyoNum( str, matchLength );
	if ( jukyoNum ) {	/*@}ԏZԍ̏ꍇ */
		for ( i = 0; i < numRecords; i++ ){
			if ( jukyoNum == pRecord->jukyoCode ) break;
			pRecord++;
		}
		if ( i == numRecords ) return 0;
	}
	else {	/* }ԏZԍ̏ꍇ */
		for ( i = 0; i < numRecords; i++ ){
			gCode = pRecord->jukyoCode;
			if ( gCode < 0 ){
				nRet = GetJukyoStr( -gCode, jukyoStr, STRMAX );
				if ( nRet < 0 )  continue;
				
				if ( strstr( str, jukyoStr )) break;
			}
			pRecord++;
		}
		if ( i == numRecords ) return 0;
		*matchLength = strlen( jukyoStr );
	}
	
	memcpy( jukyoRecord, pRecord, sizeof(JUKYO_RECORD) );
	return 1;
}


/*@w肵厚ђڎAnԊX敄ɑ΂A
@@@@@@@@@@@nԊX敄e[u̔ԍ擾B

	(in)
		cityCode : s撬R[hiTj
		choCode  : 厚R[h
		azaCode  : ڎR[h(0)
		gaikuCode: nԊX敄R[h


	߂l
		1ȏ : e[uԍ
		   0  : w肳ꂽnԊX敄ɂ͎}ԏZԍe[u
			    o^ĂȂ
		  FG[
			-101 : }ԏZR[hɃ[hĂȂ
			-102 : nԊX敄R[h擾łȂ
			-103 : e[uXg̃f[^ُ

*/

int GetJukyoTableNum( int cityCode, int choCode, int azaCode,
													int gaikuCode )
{
	GAIKU_RECORD gaikuRecord;
	int nRet,tableNum,jukyoHyoji;
	JUKYO_TABLE_LIST *pTableList;
	unsigned int checksum;
	
	if ( ! m_aryRecord  ) return -101;

	/* nԊX敄R[h̎擾 */
	nRet = GaikuRecGet( cityCode ,choCode, azaCode, gaikuCode, 
											&gaikuRecord, &jukyoHyoji );
	if ( nRet < 0 ) {
		return -102;
	}

	tableNum = gaikuRecord.jukyoTableNum;
	if ( ! tableNum ) return 0;
	
	/* `FbNT`FbN */
	pTableList = &m_jukyoTableList[ tableNum ];
	checksum = ( cityCode + choCode + azaCode + gaikuCode ) << 16;
	if ( (((unsigned int) pTableList->numRecords ) & 0xffff0000 )  != checksum ){
		return -103;
	}
	
	return tableNum;
}

/*@nԕ擾B

	(in)
		chibanStrNum : nԕԍ
		strMax : obt@ijukyoStrj̃oCg
	(out)
		jukyoStr : nԕ
		
	߂l
	@@@ 0 ; I
		 : G[
		  -1 ; nԕ񃌃R[hɃ[hĂȂ
		  -2 : XR[hɑΉ郌R[hȂ
		  -3 : obt@̒Ȃ
*/

int GetJukyoStr( int chibanStrNum, char *jukyoStr, int strMax )
{
	char *p;
	
	if ( ! m_stringRecord ) return -1;

	if ( chibanStrNum < 0 ) chibanStrNum = chibanStrNum;	
	if ( chibanStrNum >= m_stringNumRecords ) return -2;
	
	p = m_stringRecord[ chibanStrNum ].str;
	if ( strlen(p) >= (unsigned int)strMax ) return -4;
	
	strcpy( jukyoStr, p+2 );	/* +2͐擪́폜邽 */
	
	return 0;
}


/*
	̐擪ɂ}ԁAZԍ擾B

	(in)
		str : 

	(out)
		matchLength : ڕ̒("""["܂ށj
		              svȏꍇNULL

	߂l 
		1ȏF@}ԁAZԍȉꍇj
		0@@F@̎}ԁAZԍł͂Ȃ
		
	E}ԁAZԍƂ݂Ȃ
	@Zp̕т̌オ
	@"Ԓn","", "|","[","\","]","","m"
	@̂ꂩ̕ŏI镶B
	  
*/
		
int GetJukyoNum( char *str, int *matchLength )
{
	char *pJukyoNum;
	int nMatch,numValue;
	
	numValue = NumStr2Int( str, &nMatch );
	if ( nMatch == 0 ) {
		if ( matchLength ) *matchLength = 0;
		return 0;
	}
	if ( matchLength == NULL ) return numValue;
	
	pJukyoNum = strstr( str, "Ԓn" );
	if ( ! pJukyoNum ) {
		pJukyoNum = sjispbrk( str, "|[\]-̃m" );
		if ( ! pJukyoNum ) goto ret;
		else nMatch += pJukyoNum + 2 - str;
	}
	else nMatch += pJukyoNum + 4 - str;

ret:
	*matchLength = nMatch;
	return numValue;
}



