/*
* [postindex.c]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/***********************************************************************

	PostIndex Function : X֔ԍCfbNXR[h֐

************************************************************************
*/

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "geocoder.h"
#include "gcjlib.h"

/*-------------------------
	ϐ
---------------------------
*/

	/* 厚R[ht@C */
static POST_INDEX_HEADER m_postIndexHeader;
static POST_INDEX *m_aryRecord;

static int m_numRecords;


/*---------------------------------------------------------------------

	X֔ԍCfbNXt@C̓eɊi[B
		
	(in)
		fileName : X֔ԍCfbNXt@C̖
	
	E͂̊֐ŊmۂB
	ȄIAgcjChoRecEnd()ĂяoŃJB
	
	߂l
		0ȏ : i[R[h
		F	G[
			-1 : mۂłȂ
			-2 : t@CI[vłȂ
			-3 : t@CID̕񂪈Ⴄ
			-4ȍ~ : t@C̃[hG[
			
-----------------------------------------------------------------------
*/

int PostIndexLoad( char *fileName )
{
	FILE *fpPostIndex;
	int n,nRet;
	
	fpPostIndex = fopen( fileName, "rb" );
	if ( fpPostIndex == NULL ) return -2;
	
	/* wb_[ */
	n = fread( &m_postIndexHeader, sizeof( m_postIndexHeader ), 1, fpPostIndex );
	if ( n != 1 ) { nRet = -4; goto err; }

	if ( strcmp( m_postIndexHeader.fileId, FILE_ID_POST_INDEX ) ) { nRet = -3; goto err; }
	m_numRecords = m_postIndexHeader.numRecords;
	
	/* R[h{ */
	m_aryRecord = (POST_INDEX*) malloc( sizeof(POST_INDEX) * m_numRecords );
	if ( ! m_aryRecord ){ nRet = -1; goto err; }

	n = fread( m_aryRecord, sizeof(POST_INDEX), m_numRecords, fpPostIndex );
	if ( n != m_numRecords ) { nRet = -6; goto err; }
	
	fclose( fpPostIndex );
	return m_numRecords;

err:
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	fclose( fpPostIndex );
	return nRet;
}


/*---------------------------------------------------------------------

	X֔ԍCfbNX̏Is
	
	EmۂJB
	
	߂l
		0 : 	I
		
-----------------------------------------------------------------------
*/

int PostIndexEnd()
{
	if ( m_aryRecord ) {
		free( m_aryRecord );
		m_aryRecord = NULL;
	}
	
	return 0;
}

/*---------------------------------------------------------------------

	X֔ԍCfbNX̃R[h̐擾B
	
	߂l
		0ȏ : R[h
		F	G[
			-1 : X֔ԍCfbNXɃ[hĂȂ
			
-----------------------------------------------------------------------
*/

int PostIndexNumRecords()
{
	if ( ! m_aryRecord  ) return -1;

	return m_numRecords;	
}

/*---------------------------------------------------------------------

	X֔ԍCfbNXR[h̓e擾B
	
	(in)
		postCode : X֔ԍiVj
	(out)
		cityCode  : s撬R[h
		choRecord : 厚R[h
		
	߂l
		0 : 	I
		F	G[
			-1 : X֔ԍCfbNXR[hɃ[hĂȂ
			-2 : w肳ꂽX֔ԍȂ
			-3 : ̑̃G[

	E̓oCiT[`ōsĂB
				
-----------------------------------------------------------------------
*/

int PostIndexGet( int postCode, int *cityCode ,int *choCode )
{
	int found,index,cmp;
	int upperIndex,lowerIndex;

	if ( ! m_aryRecord  ) return -1;

	found = 0;	
	
	upperIndex = m_numRecords - 1;
	lowerIndex = 0;

	while(1){
		index = ( upperIndex + lowerIndex ) / 2;
		if ( ( cmp = m_aryRecord[ index ].postCode - postCode ) == 0 ) {
			found = 1;
			break;
		}
		else if (cmp > 0 ) upperIndex = index - 1;
		else lowerIndex = index + 1;

		if ( lowerIndex > upperIndex ) break;
	}		

	if (found) {
		if ( cityCode == NULL || choCode == NULL ) return -3;
		*cityCode = m_aryRecord[ index ].cityCode; 
		*choCode = m_aryRecord[ index ].choCode; 
		return 0;
	}
	else return -2;
}

