/*
* [gcjlib.h]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/


#ifndef _GCJLIB_H
#define _GCJLIB_H

#include "geocoder.h"
#include "geocoderja.h"


/**********************************************************************

  Funcitons : ֐ 

***********************************************************************
*/

#ifdef _cplusplus_
extern "C" {
#endif

/*---------------------------------------------------------------------
	ʃx̊֐
-----------------------------------------------------------------------
*/

/* ZDB֐ */
char *gcjDbFilePath( int fileId );
char *gcjDbErrorText();

/* s惌R[h֐ */
int GyoseiRecLoad( char *fileName );
int GyoseiRecEnd();
int GyoseiRecGet( int gyoseiCode , GYOSEI_RECORD *gyoseiRecord );

/* s於nbVe[u֐ */
int GyoseiHashLoad( char *fileName );
int GyoseiHashEnd();
int GyoseiHashSearch( char *str, int *matchLength, int *shubetsu,
												int *codeArray, int maxArray );

/* 厚R[h֐ */
int ChoRecLoad( char *fileName );
int ChoRecSave( char *fileName );
int ChoRecEnd();
int ChoRecNumRecords( int cityCode );
int ChoRecGet( int cityCode ,int choCode, CHO_RECORD *choRecord );
int ChoRecPut( int cityCode ,int choCode, CHO_RECORD *choRecord );

/* 厚nbVe[u֐ */
int ChoHashLoad( char *fileName );
int ChoHashEnd();
int ChoHashSearch( int cityCode, char *str, int *matchLength, int *choCode );

/* ڎR[h֐ */
int AzaRecLoad( char *fileName );
int AzaRecSave( char *fileName );
int AzaRecEnd();
int AzaRecNumRecords( int cityCode, int choCode );
int AzaRecGet( int cityCode, int choCode, int azaCode, AZA_RECORD *azaRecord );
int AzaRecPut( int cityCode, int choCode, int azaCode, AZA_RECORD *azaRecord );
int AzaRecSearch( int azaTableNum, char *str, int *matchLength, AZA_RECORD *azaRecord );

/* nԊX敄R[h֐ */
int GaikuRecLoad( char *recordFileName, char *stringFileName );
int GaikuRecSave( char *fileName );
int GaikuRecEnd();
int GaikuRecNumRecords( int cityCode, int choCode, int azaCode );
int GaikuRecGetList( int cityCode, int choCode, int azaCode, 
								int *codeArray, int recordMax );
int GaikuRecGet( int cityCode, int choCode, int azaCode, int gaikuCode, 
									GAIKU_RECORD *gaikuRecord, int *jukyoHyoji );
int GaikuRecPut( int cityCode, int choCode, int azaCode, int gaikuCode, 
												GAIKU_RECORD *gaikuRecord );
int GaikuRecSearch( int gaikuTableNum, char *str, 
									int *matchLength, GAIKU_RECORD *gaikuRecord );
int GetGaikuTableNum( int cityCode, int choCode, int azaCode );

/* }ԏZԍR[h֐ */
int JukyoRecLoad( char *recordFileName, char *stringFileName );
int JukyoRecSave( char *fileName );
int JukyoRecEnd();
int JukyoRecNumRecords( int cityCode, int choCode, int azaCode,
													int gaikuCode );
int JukyoRecGetList( int cityCode, int choCode, int azaCode, int gaikuCode,
								int *codeArray, int recordMax );
int JukyoRecGet( int cityCode, int choCode, int azaCode,
				int gaikuCode, int jukyoCode, JUKYO_RECORD *jukyoRecord );
int JukyoRecPut( int cityCode, int choCode, int azaCode,
				 int gaikuCode, int jukyoCode, JUKYO_RECORD *jukyoRecord );
int JukyoRecSearch( int jukyoTableNum, char *str, 
							int *matchLength, JUKYO_RECORD *jukyoRecord );
int GetJukyoTableNum( int cityCode, int choCode, int azaCode,
													int gaikuCode );

/* X֔ԍCfbNX֐ */
int PostIndexLoad( char *fileName );
int PostIndexEnd();
int PostIndexNumRecords();
int PostIndexGet( int postCode, int *cityCode ,int *choCode );

/* 25000nR[h֐ */
int Chimei25kRecLoad( char *fileName );
int Chimei25kRecEnd();
int Chimei25kRecNumRecords();
int Chimei25kRecGet( int chimeiCode , CHIMEI25K_RECORD *chimei25kRecord );

/* 25000nnbVe[u֐ */
int Chimei25kHashLoad( char *fileName );
int Chimei25kHashEnd();
int Chimei25kHashSearch( char *str, int *codeArray, int maxArray );

/* CfbNX֐ */
int MojiIndexLoad( char *fileName );
int MojiIndexEnd();
int MojiIndexSearch( char *str, SOURCE_RECORD *codeArray, int maxArray );

/* ̑ */
int gcjStrcpy( char *dest, char *source, int destBytes );
int gcjStrcat( char *dest, char *source, int destBytes );
int gcjGetSeireiCode( int gyoseiCode );

int NumStr2Int( char *str, int *matchLength );
char *sjispbrk( char *str, char *chars );
int IsSjisKanji( char *p );
int LastCharIsNumeric( char *str );
int Int2ZenkakuStr( int n, char *str, int strBytes );

/*---------------------------------------------------------------------
	ʃx̊֐
-----------------------------------------------------------------------
*/

int gcjGetGyoseiCode( char *str, int *matchLength, int codeArray[], int maxArray );
int gcjGetChoCode( int cityCode, char *str, int *matchLength, int *choCode );
int gcjGetAzaCode( int cityCode, int choCode, char *str, int *matchLength, int *azaCode );

#ifdef _cplusplus_
}
#endif

#endif

