/*
* [geocoder.h]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
* This program is free software; you can redistribute and/or modify
* it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
* USA.
*
* See the COPYING file for more information.
*
*
*/

/*
//  ZWIR[_@wb_[t@C
//
//
//
*/

#ifndef _GEOCODER_H
#define _GEOCODER_H

#include "geocoderja.h"

/**********************************************************************
                             ʓIȍ
-----------------------------------------------------------------------
*/           

/* sR[h̍ől */
#define GYOSEI_MAX 48000


/* o͌` */
#define OUT_KEN 		0x1
#define OUT_SEIREI		0x2
#define OUT_SHICHO		0x4
#define OUT_GUN			0x8
#define OUT_CITY		0x10
#define OUT_CHO			0x20
#define OUT_AZA			0x40
#define OUT_GAIKU		0x80
#define OUT_JUKYO		0x100

#define OUT_CHOME_STR	0x1000
#define OUT_BANCHI_STR	0x2000
#define OUT_CHOME_KANJI	0x4000


/**********************************************************************
                           ZDBt@C֘A
-----------------------------------------------------------------------
*/           

/* #1 : s惌R[ht@C --------------------------------------*/
#define ID_GYOSEI 1
#define FILE_NAME_GYOSEI "gcj_gyosei.rec"
#define FILE_ID_GYOSEI "gyorecd"

#define NEW_CODE_MAX 3
#define GYOSEI_NAME_LEN 23
#define GYOSEI_KANA_LEN 15

typedef struct{
    char fileId[8];      /* t@CID */
    int version;         /* o[W */
    char notUsed[8];     /* gp */
    int numRecords;      /* s惌R[h */
} GYOSEI_HEADER;

typedef struct {
    int shubetsu;                    /*  */
    int kenCode;                     /* R[h2 */
    int shichoCode;                  /* xR[h5 */
    int gunCode;                     /* SߎsR[h5 */
    int cityCode;                    /* s撬R[h5 */
    int removeFlag;                  /* p~tO */
    int newGyoseiCode[NEW_CODE_MAX]; /*ύX̎s撬R[h */
    char name[GYOSEI_NAME_LEN+1];    /*  */
    char kana[GYOSEI_KANA_LEN+1];    /*  */
    int choHashTableNum;             /* 厚nbVe[uԍ */
    int latitude;                    /* ܓxi~bj*/
    int longitude;                   /* oxi~bj*/
} GYOSEI_RECORD;

/* #2 : s於nbVt@C ------------------------------------*/
#define ID_GYOSEIHASH 2
#define FILE_NAME_GYOSEIHASH "gcj_gyosei.hsh"
#define FILE_ID_GYOSEIHASH "gyohash"
typedef struct{
    char fileId[8];      /* t@CID */
    int version;         /* o[W */
    char notUsed[4];     /* gp */
    int numRecords;      /* nbVR[h */
    int hashSize;        /* nbVTCY */
} GYOSEI_HASH_HEADER;

typedef struct {
    char name[GYOSEI_NAME_LEN+1]; /* p */
    int gyoseiCode;               /* sR[h */
    int shubetsu;                 /*  */
    int nextBucketNum;            /* ̃oPbgԍ */
} GYOSEI_HASH_BUCKET;

/* #3 : 厚R[ht@C -----------------------------------------*/
#define ID_CHO 3
#define FILE_NAME_CHO "gcj_cho.rec"
#define FILE_ID_CHO "chorecd"
#define CHO_ATTR_CHOMOKU    1
#define CHO_ATTR_AZA        2

#define CHO_NAME_LEN 30
#define CHO_KANA_LEN 28

typedef struct{
    char fileId[8];        /* t@CID */
    int version;           /* o[W */
    char notUsed[8];       /* gp */
    int numRecords;        /* 厚R[h */
    int numBytes;          /* 1R[h̃oCg */
    int offsetRecordTop;   /* R[h擪̃oCgʒu */
} CHO_HEADER;

typedef struct {
    int numRecords;       /* 厚R[h */
    int startRecNum;      /* 擪̃R[hԍ */
} CHO_OFFSET;

typedef struct {
    int choCode;               /* 厚R[h */
    int reserved;              /* VXep */
    char name[CHO_NAME_LEN+1]; /* 厚 */
    char kana[CHO_KANA_LEN+1]; /* ǂ݉ */
    int postCode;               /* X֔ԍ */
    int azaTableNum;           /* ڎe[uԍ */
    int chibanTableNum;        /* nԊX敄e[uԍ*/
    int latitude;              /* ܓxi~b) */
    int longitude;             /* oxi~bj */
} CHO_RECORD;


/* #4 : 厚nbVt@C -----------------------------------------*/
#define ID_CHOHASH 4
#define FILE_NAME_CHOHASH "gcj_cho.hsh"
#define FILE_ID_CHOHASH "chohash"
typedef struct{
    char fileId[8];       /* t@CID */
    int version;          /* o[W */
    char notUsed[16];     /* gp */
    int hashTableBytes;   /* nbVe[ũoCg */
    int numRecords;       /* ̃R[h */
} CHO_HASH_HEADER;

typedef struct {
    char name[CHO_NAME_LEN+2];
    int choCode;
    int nextBucketNum;
} CHO_HASH_BUCKET;


/* #5 : ڎR[ht@C -----------------------------------------*/
#define ID_AZA 5
#define FILE_NAME_AZA "gcj_aza.rec"
#define FILE_ID_AZA "azarecd"

#define AZA_NAME_LEN 30
#define AZA_KANA_LEN 28

#define CHO_MAX 150000

typedef struct{
    char fileId[8];      /* t@CID */
    int version;         /* o[W */
    char notUsed[8];     /* gp */
    int maxNumTables;    /* gp */
    int numTables;       /* ڎe[u */
    int numTotalRecords; /* ڎR[h */
} AZA_HEADER;

typedef struct {
    int cityCode;          /* Ts撬R[h */
    int choCode;           /* 厚R[h */
    int numRecords;        /* ڎR[h */
    int numSerialChomoku;  /* Aڂ̐ */
    int startRecNum;       /* e[u擪̃R[hԍ */
} AZA_TABLE_LIST;

typedef struct {
    int choazaCode;            /* 厚R[h{ڎR[h */
    int reserved;              /* VXep */
    char name[AZA_NAME_LEN+1]; /* ڎ */
    char kana[AZA_KANA_LEN+1]; /* ڎ */
    int chibanTableNum;        /* nԊX敄e[uԍ */
    int latitude;              /* ܓxi~bj */
    int longitude;             /* oxi~bj */
} AZA_RECORD;

/* #6 : nԁAX敄R[ht@C ---------------------------------*/
#define ID_GAIKU 6
#define FILE_NAME_GAIKU "gcj_gaiku.rec"
#define FILE_ID_GAIKU "gaikurc"

typedef struct{
    char fileId[8];      /* t@CID */
    int version;         /* o[W */
    char notUsed[8];     /* gp */
    int maxNumTables;    /* gp */
    int numTables;       /* nԊX敄e[u */
    int numTotalRecords; /* nԊX敄R[h */
} GAIKU_HEADER;

typedef struct {
    int cityCode;          /* Ts撬R[h */
    int choCode;           /* 厚R[h */
    int azaCode;           /* ڎR[h */
    int numRecords;        /* nԊX敄R[h */
    int startRecNum;       /* e[u擪̃R[hԍ */
    int jukyoHyoji;        /* Z\tO */
} GAIKU_TABLE_LIST;

typedef struct {
    int gaikuCode;         /* nԊX敄R[h */
    int jukyoTableNum;     /* }ԏZԍe[uԍ */
    int latitude;          /* ܓxi~bj */
    int longitude;         /* oxi~bj */
} GAIKU_RECORD;

/* #7 : }ԁAZԍR[ht@C ---------------------------------*/
#define ID_JUKYO 7
#define FILE_NAME_JUKYO "gcj_jukyo.rec"
#define FILE_ID_JUKYO "jukyorc"

typedef struct{
    char fileId[8];      /* t@CID */
    int version;         /* o[W */
    char notUsed[8];     /* gp */
    int maxNumTables;    /* gp */
    int numTables;       /* }ԏZԍe[u */
    int numTotalRecords; /* }ԏZԍR[h */
} JUKYO_HEADER;

typedef struct {
    int numRecords;        /* 16rbg : ʃR[h̃`FbNT */
                           /* 16rbg : }ԏZԍR[h */
    int startRecNum;       /* e[u擪̃R[hԍ */
} JUKYO_TABLE_LIST;

typedef struct {
    int jukyoCode;         /* }ԏZԍR[h */
    int latitude;          /* ܓxi~bj */
    int longitude;         /* oxi~bj */
} JUKYO_RECORD;

/* #8 : ԃR[ht@C -------------------------------------------*/
#define ID_MAGOBAN 8
#define FILE_NAME_MAGOBAN "gcj_magoban.rec"
#define FILE_ID_MAGOBAN "magoban"

/* #9 : e[ut@C -----------------------------------------*/
#define ID_STRING 9
#define FILE_NAME_STRING "gcj_string.rec"
#define FILE_ID_STRING "stringr"

    /* nԕ̃oCg */
#define CHIBANSTR_BYTES 16

typedef struct{
    char fileId[8];      /* t@CID */
    int version;         /* o[W */
    char notUsed[12];    /* gp */
    int recordBytes;     /* PR[h̃oCg */
    int numRecords;      /* 񃌃R[h */
} STRING_HEADER;

typedef struct {
    char str[CHIBANSTR_BYTES];  /*  */
} STR_RECORD;

/* #10 : X֔ԍt@C ------------------------------------------*/
#define ID_MPOST 10
#define FILE_NAME_MPOST "gcj_multipost.rec"
#define FILE_ID_MPOST "multpost"

typedef struct{
    char fileId[8];
    int version;
    char notUsed[12];
    int numOffsets;
    int numRecords;
} MULTI_POST_HEADER;


typedef struct {
    int choCode;
    long offset;
} MULTI_POST_OFFSET;


/* #11 : \LoG[Vt@C ------------------------------------*/
#define ID_VARIATION 11
#define FILE_NAME_VARIATION "gcj_variation.csv"


/* #12 : sXgt@C ------------------------------------------*/
#define ID_GYOSEI_LIST 12
#define FILE_NAME_GYOSEI_LIST "gcj_gyoseimei.csv"


/* #13 : X֔ԍCfbNXt@C ----------------------------------*/
#define ID_POST_INDEX 13
#define FILE_NAME_POST_INDEX "gcj_post.idx"
#define FILE_ID_POST_INDEX "postidx"

typedef struct{
    char fileId[8];
    int version;
    char notUsed[16];
    int numRecords;
} POST_INDEX_HEADER;


typedef struct {
	int postCode;
    int cityCode;
    int choCode;
} POST_INDEX;


/* #14 : 25000nR[ht@C -----------------------------------------*/
#define ID_CHIMEI25K 14
#define FILE_NAME_CHIMEI25K "gcj_chimei25k.rec"
#define FILE_ID_CHIMEI25K "25krecd"


typedef struct{
    char fileId[8];         /* t@CID */
    int version;            /* o[W */
    char notUsed[16];       /* gp */
    int numRecords;         /* nR[h */
} CHIMEI25K_HEADER;

typedef struct {
	int chimeiCode;            /* nR[h */
    int cityCode;              /* s撬R[h */
    int chimeiKind;            /* n */
    char name[CHIMEI25K_NAME_LEN+1]; /* n */
    int latitude;              /* ܓxi~b) */
    int longitude;             /* oxi~bj */
} CHIMEI25K_RECORD;


/* #15 : 25000nnbVt@C -----------------------------------------*/
#define ID_CHIMEI25KHASH 15
#define FILE_NAME_CHIMEI25KHASH "gcj_chimei25k.hsh"
#define FILE_ID_CHIMEI25KHASH "25khash"
typedef struct{
    char fileId[8];       /* t@CID */
    int version;          /* o[W */
    char notUsed[12];     /* gp */
    int hashSize;         /* nbVTCY */
    int numRecords;       /* ̃R[h */
} CHIMEI25K_HASH_HEADER;

typedef struct {
    char name[CHIMEI25K_NAME_LEN+1];
    int chimeiCode;
    int nextBucketNum;
} CHIMEI25K_HASH_BUCKET;


/* #16 : CfbNXt@C -----------------------------------------*/
#define ID_MOJI_INDEX 16
#define FILE_NAME_MOJI_INDEX "gcj_moji.idx"
#define FILE_ID_MOJI_INDEX "mojindx"
typedef struct{
    char fileId[8];       /* t@CID */
    int version;          /* o[W */
    char notUsed[12];     /* gp */
    int numIndexRecords;  /* SẴ̕CfbNXR[hie[uŌ0܂ށj */
    int numSourceRecords; /* R[h */
} MOJI_INDEX_HEADER;

typedef struct {
	int numRecords;       /* ỸCfbNXR[h */
	int tableTopPos;      /* ỸCfbNXe[u擪̈ʒuB*/
} MOJI_TABLE_DATA;

typedef struct {
	int nameKind;         /* 1:s{ 2:x 3:Sߎs 4:s撬
	                         5:厚 6:ڎ 10:25000n */
	int cityCode;         /* s撬R[h */
    int choCode;          /* 厚R[h܂͒nR[h */
    int azaCode;          /* ڎR[h */
} SOURCE_RECORD;


#endif
