/*
* [mkchohash.cpp]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
*/



/*
//
// 厚R[ht@CɂāA厚̓Q̃nbVe[u쐬B
//
//  N@F mkchohash dbDirPath hashSizeFactor
//
//				dbDirPath		: ZDBi[ĂfBNg
//				hashSizeFactor	: nbVTCỶ{ɂ邩̒l
//
//  t@CtH[}bgF
//			厚R[ht@C			FGcjFileFormat#4
//			厚nbVe[ut@C	FGcjFileFromat#5
*/



/* wb_[@----------------------------------------------------------*/

#define _cplusplus_

#include "stdafx.h"
#include <windows.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <mbstring.h>
#include <crtdbg.h>

#include "geocoder.h"
#include "gcjlib.h"

/* 萔` ------------------------------------------------------------*/

#define BUCKET_MAX 400000

#define GYOSEI_MAX 48000

#define DEFAULT_HASH_SIZE_FACTOR 2

#define VAR_CMAX 30
#define VAR_NUMMAX 500

/* ^` ------------------------------------------------------------*/




/* ϐ` ------------------------------------------------------*/

CHO_HASH_HEADER m_choHashHeader;
long 			m_hashTableOffset[ GYOSEI_MAX ];
CHO_HASH_BUCKET m_aryBucket[ BUCKET_MAX ]; 


struct {
	char from[VAR_CMAX+1];
	char to[VAR_CMAX+1];
} m_charVariation[VAR_NUMMAX];
int m_variationMax;

char errStr[STRMAX+1];

int m_currentBucketNum;

int m_numCollisions;
int m_maxCollision;
int m_maxCollisionCityCode;

/*@֐` -----------------------------------------------------*/

int MakeHashTable( FILE *fpHash, double hashSizeFactor );

int WriteToHashTableWithVariation( int replacePos,
								   int cityCode, int choCode, char *choName, 
								   int hashSize, long *pHashTable );

int WriteToHashTable( int cityCode, int choCode, char *choName, 
				int hashSize, long *pHashTable );


int main(int argc, char* argv[])
{
	FILE *fpHash,*fpVar;
	long nRet;
	double hashSizeFactor;
	char *recName,*varName,*hashName,buffer[STRMAX+1],*p;
	int i;
	
	if ( argc < 2 ) {
		printf(" mkchohash dbDirPath hashSizeFactor" );
		return 0;
	}
	else if ( argc == 2 ) hashSizeFactor = DEFAULT_HASH_SIZE_FACTOR;
	else {
		hashSizeFactor = atof( argv[2] );
		if ( hashSizeFactor <= 0 ) {
			printf( " nbVTCYmFĉBF size = %d\n", hashSizeFactor );
			return 0;
		}
	}
	
	nRet = gcjDbSetPath( argv[1] );
	if ( nRet < 0 ){
		printf( "ZDB̃pXݒł܂B");
		return 0;
	}
	
	/* \LoG[Vt@C̓ǂݍ */
	varName = gcjDbFilePath( ID_VARIATION );
	if ( ! varName ){
		printf( "\LoG[Vt@C̃pX擾ł܂B" );
		return 0;
	}
	fpVar = fopen( varName, "r" );
	if ( fpVar == NULL ){
		printf( "\LoG[Vt@CJ܂B :  FileName = %s\n", varName );
		return 0;
	}
	
	i = 0;
	while( ! feof( fpVar ) ){
		p = fgets( buffer, STRMAX, fpVar );
		if ( ! p ) break;
		
		p = (char*) _mbschr( (unsigned char*)buffer, ',' );
		if ( !p ) continue;
		*p = '\0';
		
		gcjStrcpy( m_charVariation[i].from, buffer, VAR_CMAX );
		*( p + 1 + strlen(p+1) - 1 ) = '\0'; 
		gcjStrcpy( m_charVariation[i].to, p+1, VAR_CMAX );
		i++;
		if ( i == VAR_NUMMAX ) break;
	}
	m_variationMax = i;
	fclose( fpVar );
		
	/* 厚R[ht@C̓ǂݍ */
	recName = gcjDbFilePath( ID_CHO );
	if ( ! recName ){
		printf( "厚R[ht@C̃pX擾ł܂B" );
		return 0;
	}
	nRet = ChoRecLoad( recName );
	if ( nRet == -2 ){
		printf( "t@CJł܂BF recFileName = %s\n", recName );
		return 0;
	}
	else if ( nRet < 0 ){
		printf( "厚R[ht@Cǂݍގł܂BF recFileName = %s@: code = %d\n", recName, nRet );
		return 0;
	}
	
	/* 쐬钬厚nbṼI[v */
	hashName = gcjDbFilePath( ID_CHOHASH );
	if ( ! hashName ){
		printf( "厚nbVt@C̃pX擾ł܂B" );
		return 0;
	}
	fpHash = fopen( hashName, "wb" );
	if ( fpHash == NULL ){
		printf( "t@C쐬ł܂B :  hashFileName = %s\n", hashName );
		ChoRecEnd();
		return 0;
	}
	
	/* nbVe[u̍쐬ƃt@C */
	nRet = MakeHashTable( fpHash, hashSizeFactor );
	
	ChoRecEnd();
	fclose( fpHash );
	return 0;
}


/*
	nbVe[u쐬B
 	 
	߂lF 0:@I
	@@@@-1F@G[
*/

int MakeHashTable( FILE *fpHash, double hashSizeFactor )
{
	char *choName;
	int i,n,nRet,hashSize,cityCode;
	int choCode;
	int currentHashTablePos;
	long allocSize,*hashTableTop,*pHashTable,numRecords;
	CHO_RECORD choRecord;

	strcpy( errStr, "" );
	
	/* nbVe[ȕ */
		/* ̊m */
	allocSize = (long) (BUCKET_MAX * hashSizeFactor) ;
	hashTableTop = (long*) calloc( allocSize, sizeof(long) );
	if ( ! hashTableTop ){
		strcpy( errStr, "#1 :  Memory allocate error." );
		goto err;
	}

	/* ۂ̃nbVe[u̍쐬 */
	
	m_currentBucketNum = 1;
	currentHashTablePos = 1;	/* long ̔zvfԍŕ\ */
								/* 0͓o^ĂȂ\ */
	m_numCollisions = 0;
	m_maxCollision = 0;

	for ( cityCode = 1000; cityCode < GYOSEI_MAX; cityCode++ ){

		numRecords = ChoRecNumRecords( cityCode );
		if ( numRecords == 0 ) continue;
		
printf( "city code = %d", cityCode );
		/* nbVe[uʒu̓o^ */
		m_hashTableOffset[ cityCode ] = currentHashTablePos;
		
		/* nbVTCY̌vZ = 厚  hashSizeFactorŊ@*/
		hashSize = (int)(numRecords * hashSizeFactor);
		if ( !( hashSize % 2 )) hashSize++;
		
		/* nbVe[u̗eʂ𒴂ĂȂ`FbN */
		if ( ( n = currentHashTablePos + hashSize + 2 ) > allocSize ){
			sprintf( errStr, "#4 : hash table pos exceeds limit. n = %d\n", n );
			goto err;
		}
		
		/* nbVe[ȕ */		
		pHashTable = hashTableTop + currentHashTablePos;
		*pHashTable = cityCode;
		*(pHashTable+1) = hashSize;

		/* nbVe[űL */
		for ( i = 0; i < numRecords; i++ ){
			nRet = ChoRecGet( cityCode, i+1, &choRecord );
			if ( nRet < 0 ){
				sprintf( errStr, "#5 : cho record error. err = %d\n", nRet );
				goto err;
			}
			choName = choRecord.name;
			choCode = choRecord.choCode;
			if ( choCode == 1 ) continue;	/* 厚͖ */
			
			if ( strlen( choName ) >= CHO_NAME_LEN ){
				sprintf( errStr, "#5 : name length error. name = %s\n", choName );
				goto err;
			}

			nRet = WriteToHashTableWithVariation( 0, cityCode, choCode, 
													choName, hashSize, pHashTable );
			if ( nRet == -1 ){
				sprintf( errStr, "#6 : bucket number exceeds limit. num = %d\n", m_currentBucketNum );
				goto err;
			}
		}

		currentHashTablePos += hashSize + 2;
printf( "  end\n" );
	}
	
	if ( m_currentBucketNum == 1 ) {	/* Ȃ */
		nRet = 0;
		goto ret;
	}
	
	printf(" Number of buckets = %d\n", m_currentBucketNum );
	printf(" Number of collisions = %d\n", m_numCollisions );
	printf(" Mean collision rate = %.1f\n", 1.0 + m_numCollisions / (double) m_currentBucketNum );
	printf(" Maximum number of collisons = %d  at cityCode = %d\n", m_maxCollision, 
															m_maxCollisionCityCode );
	
	/* nbVe[ȕo */
		/* wb_ */
	strcpy( m_choHashHeader.fileId, FILE_ID_CHOHASH );
	m_choHashHeader.version = 1;
	m_choHashHeader.hashTableBytes = currentHashTablePos * sizeof(long);
	m_choHashHeader.numRecords = m_currentBucketNum;

	n = fwrite( &m_choHashHeader, sizeof(m_choHashHeader), 1, fpHash );
	if ( !n ){
		strcpy( errStr, "#7 : hash table header write error." );
		goto err;
	}

		/* e[uItZbg@*/
	n = fwrite( m_hashTableOffset, sizeof(m_hashTableOffset), 1, fpHash );
	if ( !n ){
		strcpy( errStr, "#8 : hash table header write error." );
		goto err;
	}
		
		/* e[u{ */
	n = fwrite( hashTableTop, sizeof(long), currentHashTablePos, fpHash );
	if ( n != currentHashTablePos ) {
		strcpy( errStr, "#9 : hash table write error." );
		goto err;
	}
	
		/* oPbg */
	n = fwrite( m_aryBucket, sizeof(CHO_HASH_BUCKET), m_currentBucketNum, fpHash );
	if ( n != m_currentBucketNum ) {
		strcpy( errStr, "#10 : hash bucket write error." );
		goto err;
	}
	
	nRet = 0;

ret:
	if ( hashTableTop ) free( hashTableTop );
	ChoRecEnd();
	return nRet;

err:
	printf( "Error%s    at : MakeHashTable()\n", errStr );
	nRet = -1;
	goto ret;
}

/*
	replacePos : choName̒̕uJnoCgʒui擪0j
	
	߂l=  0:I
	        -1:oPbgeʈtɂȂB
*/

int WriteToHashTableWithVariation( int replacePos,
								   int cityCode, int choCode, char *choName, 
								   int hashSize, long *pHashTable )
{
	int i,nret,len1,len2,foundPos,topPos,maxLength;
	char buff[STRMAX+1],*from,*to,*p,*pReplace;
	
	WriteToHashTable( cityCode, choCode, choName, hashSize, pHashTable );

	m_currentBucketNum++;
	if ( m_currentBucketNum >= BUCKET_MAX ) return -1;

	if ( m_variationMax > 0 ){
loop:
		pReplace = choName + replacePos;
		/* ̃oG[Vo^ */
			/* ܂AԐ擪ɂ镶̃oG[VłԒ̂{ */
		topPos = strlen( choName ) + 1;
		maxLength = 0;
		for ( i = 0; i < m_variationMax; i++ ){

			from = m_charVariation[ i ].from;

				/* from#΃Rg */
			if ( strstr( from, "#") || strstr( from, "") ) continue;

			if ( p = strstr( pReplace, from )) {
				foundPos = p - choName;
				if ( topPos > foundPos ) {
					topPos = foundPos;
					maxLength = strlen( from );
				}
				else if ( topPos == foundPos ){
					if ( maxLength < (int) strlen( from ) ) maxLength = strlen( from );
				}
			}
		}
		if ( maxLength == 0 ) return 0;
		
			/* ۂɒus */
		for ( i = 0; i < m_variationMax; i++ ){

			from = m_charVariation[ i ].from;

				/* from#΃Rg */
			if ( strstr( from, "#") || strstr( from, "") ) continue;

			if ( p = strstr( pReplace, from )) {

				/* 擪Ɉԋ߂Aő咷̕ɊւĒu */
				len1 = p - choName;
				if ( len1 < 0 || len1 > (int)strlen(choName) ) continue;
				if ( len1 != topPos || (int) strlen( from ) != maxLength ) continue;
				
				to = m_charVariation[ i ].to;

				memcpy( buff, choName , len1 );
				memcpy( buff + len1, to, len2 = strlen(to) );
				*( buff + len1 + len2 ) = '\0';
				gcjStrcat( buff, p + strlen(from), STRMAX );
				
				/* uŁAċAIɌĂяo */
				nret = WriteToHashTableWithVariation( len1 + strlen( from ),
							cityCode, choCode, buff, hashSize, pHashTable );
				if ( nret < 0 ) return -1;
				
			}
		}
		
		/* replacePosfromAɂ炵čČ */
		replacePos += maxLength;
		goto loop;
	}

	return 0;
}


/* 厚nbVe[uɓo^B

	߂l= gpĂȂB
*/

int WriteToHashTable( int cityCode, int choCode, char *choName, 
											int hashSize, long *pHashTable )
{
	char choBuff[STRMAX+1];
	int n,hashValue,bucketNum;
	CHO_HASH_BUCKET *pBucket;

	/* QSoCg𐮐lƂČȂănbVlvZ@*/
	if ( strlen( choName ) == 2 ){
		gcjStrcpy( choBuff, choName, STRMAX );
		gcjStrcat( choBuff, "\xff\xff", STRMAX );
		hashValue = ( *(unsigned long*) choBuff ) % hashSize;
	}
	else hashValue = ( *(unsigned long*) choName ) % hashSize;

	/* e[uփoPbgԍo^ */
	bucketNum = *( pHashTable + hashValue + 2 );
	if  ( bucketNum > 0 ) { /* Փ˂NĂꍇ */
		n = 0;
		while(1){
			if ( m_aryBucket[ bucketNum ].nextBucketNum  == 0 ){
				m_aryBucket[ bucketNum ].nextBucketNum = m_currentBucketNum;
				m_numCollisions++;
				break;
			}
			bucketNum = m_aryBucket[ bucketNum ].nextBucketNum;
			n++;
		}
		if ( n > m_maxCollision ) {
			m_maxCollision = n;
			m_maxCollisionCityCode = cityCode;
		}
	}
	else *( pHashTable + hashValue + 2 ) = m_currentBucketNum;

	/* oPbg̋L */
	pBucket = &m_aryBucket[ m_currentBucketNum ];
	gcjStrcpy( pBucket->name, choName, CHO_NAME_LEN );

	pBucket->choCode = choCode;
	pBucket->nextBucketNum = 0;
		
	return 0;
}

