/*
* [mkgyoseihash.cpp]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
*
*/



/*
//
// sXgt@CɂāAs̓Q̃nbVe[u쐬B
//
//  N@F mkgyoseihash dbDirName hashSize
//
//				dbDirName		: ZDBi[ĂfBNg
//				hashSize		: nbVTCYiȗꍇ5003j
//
//  t@CtH[}bgF
//			sXgt@C		FGcjFileFormat#12
//			nbVe[ut@C	FGcjFileFromat#2
//
//		EQƂsXgt@C dbDirName Ɋi[Ă
//		  "gcj_gyoseimei.csv"Ƃ̂̃t@CłB
//
*/


/* wb_[@----------------------------------------------------------*/

#include "stdafx.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <mbstring.h>

#define _cplusplus_
#include "geocoder.h"
#include "gcjlib.h"


/* 萔` ------------------------------------------------------------*/
#define FILE_ID_HASH "gyohash"
#define VERSION 1

#define BUCKET_MAX 10000

#define DEFAULT_HASH_SIZE 5003

#define VAR_CMAX 30
#define VAR_NUMMAX 500

/* sXgt@C(GcjFileFormat#1) ̍ڐ */
#define NUM_ITEMS 12

#define CHOSON_NAME "s撬"
#define KEN_NAME	"s{"
#define SHICHO_NAME	"x"
#define GUN_NAME	"Sߎs"

#define TYPE_KEN 1
#define TYPE_SHICHO 2
#define TYPE_GUN 3
#define TYPE_CITY 4


/* ϐ` ------------------------------------------------------*/
GYOSEI_HASH_HEADER m_gyoseiHashHeader;
GYOSEI_HASH_BUCKET m_aryBucket[ BUCKET_MAX ]; 

struct {
	char from[VAR_CMAX+1];
	char to[VAR_CMAX+1];
} m_charVariation[VAR_NUMMAX];
int m_variationMax;

int m_currentBucketNum;

/*@֐` -----------------------------------------------------*/

int MakeHashTable( FILE *fpList, FILE *fpHash, int hashSize );
int WriteToHashTableWithVariation( int replacePos,
								   int gyoseiCode, int typeNum, char *name, 
								   int hashSize, int *hashTable );
int WriteToHashTable( int gyoseiCode, int typeNum, char *name, 
											int hashSize, int *hashTable );
int split( char *str, char delimiter, char aryStr[][256], int numArray );


int main(int argc, char* argv[])
{
	FILE *fpList,*fpHash,*fpVar;
	int i,hashSize,nRet;
	char *p,*varName,*fileName,buffer[STRMAX+1];
	
	if ( argc < 2 ) {
		printf(" gyoseihash dbDirName hashSize" );
		return 0;
	}
	else if ( argc == 2 ) hashSize = DEFAULT_HASH_SIZE;
	else {
		hashSize = atoi( argv[2] );
		if ( hashSize <= 0 ) {
			printf( " nbVTCYmFĉBF size = %d\n", hashSize );
			return 0;
		}
	}

	fpList = fpHash = fpVar = NULL;
	
	/* ZDB̃fBNgݒ */
	nRet = gcjDbSetPath( argv[1] );
	if ( nRet < 0 ){
		printf( "ZDB̃pXݒł܂B");
		return 0;
	}
	
	/* \LoG[Vt@C̓ǂݍ */
	varName = gcjDbFilePath( ID_VARIATION );
	if ( ! varName ){
		printf( "\LoG[Vt@C̃pX擾ł܂B" );
		return 0;
	}
	fpVar = fopen( varName, "r" );
	if ( fpVar == NULL ){
		printf( "\LoG[Vt@CJ܂B :  FileName = %s\n", varName );
		return 0;
	}
	
	i = 0;
	while( ! feof( fpVar ) ){
		p = fgets( buffer, STRMAX, fpVar );
		if ( ! p ) break;
		
		p = (char*) _mbschr( (unsigned char*)buffer, ',' );
		if ( !p ) continue;
		*p = '\0';
		
		gcjStrcpy( m_charVariation[i].from, buffer, VAR_CMAX );
		*( p + 1 + strlen(p+1) - 1 ) = '\0'; 
		gcjStrcpy( m_charVariation[i].to, p+1, VAR_CMAX );
		i++;
		if ( i == VAR_NUMMAX ) break;
	}
	m_variationMax = i;
	fclose( fpVar );
	fpVar = NULL;

	/* sXgt@C̃I[v */
	fileName = gcjDbFilePath( ID_GYOSEI_LIST );
	if ( ! fileName ){
		printf( "sXgt@C̃pX擾ł܂B" );
		return 0;
	}
	
	fpList = fopen( fileName, "r" );
	if ( fpList == NULL ){
		printf( "t@CJł܂BF listFileName = %s\n", fileName );
		return 0;
	}
	
	/* s於nbVe[ut@C̃I[v */
	fileName = gcjDbFilePath( ID_GYOSEIHASH );
	if ( ! fileName ){
		printf( "s於nbVe[ut@C̃pX擾ł܂B" );
		goto ret;
	}
	
	fpHash = fopen( fileName, "wb" );
	if ( fpHash == NULL ){
		printf( "t@C쐬ł܂B :  hashFileName = %s\n", fileName );
		goto ret;
	}
	
	nRet = MakeHashTable( fpList, fpHash, hashSize );

ret:
	if ( fpList ) fclose( fpList );
	if ( fpHash ) fclose( fpHash );
	return 0;
}


/*
	nbVe[u쐬B
	 
	߂lF 0:@I
	@@@@-1F@G[
*/

int MakeHashTable( FILE *fpList, FILE *fpHash, int hashSize )
{
	char *p,buffer[256],nameBuff[NUM_ITEMS][256],errStr[256];
	int *hashTable;
	int n,nret,typeNum;
	char *pLineNum,*name,*pShubetsu;
	int gyoseiCode;

	strcpy( errStr, "" );
	
	/* nbVe[ȕ */
	hashTable = (int*) calloc( hashSize, sizeof(int) );
	if ( !hashTable ){
		printf( " Memory allocate error." );
		return -1;
	}
	
	/* ۂ̃nbVe[u̍쐬 */
	
	m_currentBucketNum = 1;
	while ( ! feof( fpList ) ){
		p = fgets( buffer, 256, fpList );
		if ( ! p  ) break;
		
		split( buffer, ',', nameBuff, NUM_ITEMS );
		
		pLineNum = nameBuff[0];
		pShubetsu = nameBuff[1];
		name = nameBuff[4];
		gyoseiCode = (int) atoi(nameBuff[2]);

		/* RgšĂє΂@*/
		if ( strcmp( pShubetsu, KEN_NAME ) == 0 ) typeNum = TYPE_KEN;
		else if ( strcmp( pShubetsu, SHICHO_NAME ) == 0 ) typeNum = TYPE_SHICHO;
		else if ( strcmp( pShubetsu, GUN_NAME ) == 0 ) typeNum = TYPE_GUN;
		else if ( strcmp( pShubetsu, CHOSON_NAME ) == 0 ) typeNum = TYPE_CITY;
		else continue;

		
		/* ̂Q܂͂X𒴂ꍇُ͈@*/
		if ( strlen( name ) < 4 || strlen( name ) >= GYOSEI_NAME_LEN ) {
			printf(" sQ܂͂X𒴂Ă܂B line = %s  name = %s\n", pLineNum, name );
			continue;
		}
		
		/* nbVe[u֊i[ */
		nret = WriteToHashTableWithVariation( 0, gyoseiCode, typeNum, 
													name, hashSize, hashTable );
		if ( nret == -1 ){
			sprintf( errStr, "bucket number exceeds limit. num = %d\n", m_currentBucketNum );
			goto err;
		}
	}

	if ( ferror( fpList ) ) {
		perror( "t@C̓ǂݍݒɃG[N܂B");
		strcpy( errStr, "file read  error." );
		goto err;
	}
	
	if ( m_currentBucketNum == 1 ) goto ret;


	/* t@Cwb_̏ */
			/* wb_̐ݒ */
	strcpy( m_gyoseiHashHeader.fileId, FILE_ID_GYOSEIHASH );
	m_gyoseiHashHeader.version = VERSION;
	m_gyoseiHashHeader.numRecords = m_currentBucketNum;
	m_gyoseiHashHeader.hashSize = hashSize;

	n = fwrite( &m_gyoseiHashHeader, sizeof(m_gyoseiHashHeader), 1, fpHash );
	if ( !n ) {
		strcpy( errStr, "gyosei hash header write error." );
		goto err;
	}
	
	/* nbVe[ȕo */
	
		/* e[u{ */
	n = fwrite( hashTable, sizeof(int), hashSize, fpHash );
	if ( n != hashSize ) {
		strcpy( errStr, "hash table write error" );
		goto err;
	}
	
		/* oPbg */
	n = fwrite( m_aryBucket, sizeof(GYOSEI_HASH_BUCKET), m_currentBucketNum, fpHash );
	if ( n != m_currentBucketNum ) {
		strcpy( errStr, "hash bucket write error" );
		goto err;
	}
	
ret:
	if ( hashTable ) free( hashTable );
	return 0;

err:
	printf( "Error : %s\n", errStr );
	if ( hashTable ) free( hashTable );
	return -1;

}

/*
	replacePos : name̒̕̕uꍇÃoCgʒui0j
	
	߂l=  0:I
	        -1:oPbgeʈtɂȂB
*/

int WriteToHashTableWithVariation( int replacePos,
								   int gyoseiCode, int typeNum, char *name, 
								   int hashSize, int *hashTable )
{
	int i,nret,len1,len2,foundPos,topPos,maxLength;
	char buff[STRMAX+1],*from,*to,*p,*pReplace;

	WriteToHashTable( gyoseiCode, typeNum, name, hashSize, hashTable );

	m_currentBucketNum++;
	if ( m_currentBucketNum >= BUCKET_MAX ) return -1;

	if ( m_variationMax > 0 ){
loop:
		pReplace = name + replacePos;
		/* ̃oG[Vo^ */
			/* ܂AԐ擪ɂ镶̃oG[VłԒ̂{ */
		topPos = strlen( name ) + 1;
		maxLength = 0;
		for ( i = 0; i < m_variationMax; i++ ){

			from = m_charVariation[ i ].from;

				/* from#΃Rg */
			if ( strstr( from, "#") || strstr( from, "") ) continue;

			if ( p = strstr( pReplace, from )) {
				foundPos = p - name;
				if ( topPos > foundPos ) {
					topPos = foundPos;
					maxLength = strlen( from );
				}
				else if ( topPos == foundPos ){
					if ( maxLength < (int) strlen( from ) ) maxLength = strlen( from );
				}
			}
		}
		if ( maxLength == 0 ) return 0;
		
			/* ۂɒus */
		for ( i = 0; i < m_variationMax; i++ ){

			from = m_charVariation[ i ].from;

				/* from#΃Rg */
			if ( strstr( from, "#") || strstr( from, "") ) continue;

			if ( p = strstr( pReplace, from )) {

				/* 擪Ɉԋ߂Aő咷̕ɊւĒu */
				len1 = p - name;
				if ( len1 < 0 || len1 > (int)strlen(name) ) continue;
				if ( len1 != topPos || (int) strlen( from ) != maxLength ) continue;
				
				to = m_charVariation[ i ].to;

				memcpy( buff, name , len1 );
				memcpy( buff + len1, to, len2 = strlen(to) );
				*( buff + len1 + len2 ) = '\0';
				gcjStrcat( buff, p + strlen(from), STRMAX );
				
				/* uŁAċAIɌĂяo */
				nret = WriteToHashTableWithVariation( len1 + strlen( from ),
							gyoseiCode, typeNum, buff, hashSize, hashTable );
				if ( nret < 0 ) return -1;
				
			}
		}
		
		/* replacePosfromAɂ炵čČ */
		replacePos += maxLength;
		goto loop;
	}

	return 0;
}


/* 厚nbVe[uɓo^B

	߂l= gpĂȂB
*/

int WriteToHashTable( int gyoseiCode, int typeNum, char *name, 
											int hashSize, int *hashTable )
{
	int hashValue,bucketNum;
	GYOSEI_HASH_BUCKET *pBucket;

	/* QSoCg𐮐lƂČȂănbVlvZ@*/
	hashValue = ( *(unsigned long*) name ) % hashSize;
		
	/* e[uփoPbgԍo^ */
	if ( (bucketNum = hashTable[ hashValue ]) > 0 ) {
		while(1){
			if ( m_aryBucket[ bucketNum ].nextBucketNum  == 0 ){
				 m_aryBucket[ bucketNum ].nextBucketNum = m_currentBucketNum;
				 break;
			}
			bucketNum = m_aryBucket[ bucketNum ].nextBucketNum;
		}
	}
	else hashTable[ hashValue ] = m_currentBucketNum;

		
	/* oPbgւ̊i[ */
	pBucket = & m_aryBucket[ m_currentBucketNum ];
	strncpy( pBucket->name, name, GYOSEI_NAME_LEN );
	pBucket->gyoseiCode = gyoseiCode;
	pBucket->shubetsu = typeNum;
	pBucket->nextBucketNum = 0;
		
	return 0;
}



/*
  Aw肵ŕAzɊi[B

	(in)
		 str 		:̕
	     delimiter  :؂蕶BpB
  		 numArray	:z̐
	(out) 
		aryStr		:z

  E؂蕶ŋ؂ꂽ255oCgȉłȂƂȂB
  
  ߂l@i[z̐
*/

int split( char *str, char delimiter, char aryStr[][256], int numArray )
{
	int numItems,i;
	unsigned char *pStart,*pEnd;

	for ( i = 0; i < numArray; i++ ) aryStr[i][0] = '\0';	
	numItems = 0;
	pStart = (unsigned char*) str;
	
	while( *pStart ){
		pEnd = _mbschr( pStart, (unsigned int)delimiter );
		if ( !pEnd ) break;
		
		*pEnd = '\0';
		if ( strlen( (char*)pStart )  > 255 ) *( pStart + 255 ) = '\0';
		strcpy( aryStr[ numItems ], (char*)pStart );
		numItems++;
		if ( numItems == numArray )  return(numItems);
		pStart = pEnd + 1;
	}
	if ( *pStart ){
		if ( strlen( (char*)pStart )  > 255 ) *( pStart + 255 ) = '\0';
		strcpy( aryStr[ numItems ], (char*)pStart );
		numItems++;
	}
	
	return numItems;
}

