/*
* [mkgyoseirec.cpp]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
*
*
*/



/*
//
// sXgt@CɂāAs惌R[ht@C쐬B
//
//  N@F mkgyoseirec dbDirName
//
//				dbDirName : ZDBt@CۑĂfBNg
//
//  t@CtH[}bgF
//			sXgt@C		FGcjFileFormat#12
//			s惌R[ht@C	FGcjFileFromat#1
//
//		EQƂsXgt@C dbDirName Ɋi[Ă
//		  "gcj_gyoseimei.csv"Ƃ̂̃t@CłB
//
*/


/* wb_[@----------------------------------------------------------*/

#define _cplusplus_

#include "stdafx.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <mbstring.h>

#include "geocoder.h"
#include "gcjlib.h"

/* 萔` ------------------------------------------------------------*/
#define RECORD_MAX 5000

/* sXgt@C(GcjFileFormat#12) ̍ڐƐVs撬R[h̍ő吔 */
#define NUM_ITEMS 14


#define TYPE_KEN 1
#define TYPE_SHICHO 2
#define TYPE_GUN 3
#define TYPE_CITY 4

#define CHOSON_NAME "s撬"
#define KEN_NAME	"s{"
#define SHICHO_NAME	"x"
#define GUN_NAME	"Sߎs"


/* ϐ` ----------------------------------------------------------*/

GYOSEI_HEADER m_gyoseiHeader;
int m_gyoseiRecordNum[ GYOSEI_MAX ];	/* s惌R[hԍ@GcjFileFormat#3QƗp */
GYOSEI_RECORD m_aryRecord[ RECORD_MAX ];


/*@֐` ---------------------------------------------------------*/

int MakeRecordFile( FILE *fpList, FILE *fpRec );
int split( char *str, char delimiter, char aryStr[][256], int numArray );
int GetShichoGunCode( int gyoseiCode, int numBundle );
static int dms2msec( double dms );


int main(int argc, char* argv[])
{
	FILE *fpList,*fpRec;
	int nRet;
	char *fileName;
	
	if ( argc < 2 ) {
		printf(" mkgyoseirec dbDirName " );
		return 0;
	}

	fpList = fpRec = NULL;
	
	/* ZDB̃pX̐ݒ */
	nRet = gcjDbSetPath( argv[1] );
	if ( nRet < 0 ){
		printf( "ZDB̃pXݒł܂B%s\n", argv[1] );
		return 0;
	}

	/* s惊Xgt@C̃I[v */
	fileName = gcjDbFilePath( ID_GYOSEI_LIST );
	if ( ! fileName ) {
		printf( "s惊Xgt@Ĉ̖擾ł܂B" );
		return 0;
	}
	
	fpList = fopen( fileName, "r" );
	if ( fpList == NULL ){
		printf( "t@CJł܂BF listFileName = %s\n", fileName );
		return 0;
	}

	/* s惌R[ht@C̃I[v */
	fileName = gcjDbFilePath( ID_GYOSEI );
	if ( ! fileName ) {
		printf( "s惌R[ht@Ĉ̖擾ł܂B" );
		goto ret;
	}
	
	fpRec = fopen( fileName, "wb" );
	if ( fpRec == NULL ){
		printf( "t@C쐬ł܂B :  recordFileName = %s\n", fileName );
		goto ret;
	}

	nRet = MakeRecordFile( fpList, fpRec );

ret:	
	if ( fpList ) fclose( fpList );
	if ( fpRec ) fclose( fpRec );
	return 0;
}

/*  s惌R[ht@C쐬B

	߂lF 0:@I
	@@@@-1F@G[
*/

int MakeRecordFile( FILE *fpList, FILE *fpRec )
{
	char *p,buffer[256],nameBuff[NUM_ITEMS][256],errStr[256];
	int n,typeNum,i;
	char *pLineNum,*pShubetsu,*name,kana[STRMAX+1];
	GYOSEI_RECORD *pGyoseiRec;
	int currentRecNum;
	int gyoseiCode,kenCode,shichoCode,gunCode,cityCode;
	int newGyoseiCode[NEW_CODE_MAX];
	double latitude,longitude;
	
	strcpy( errStr, "" );

	/*R[h̏ */
	currentRecNum = 1;			/* R[hԍ0̓R[htOɎgp */
	while ( ! feof( fpList ) ){
		p = fgets( buffer, 256, fpList );
		if ( ! p  ) break;

		if ( strlen( buffer ) == 0 ) continue;
		
		/* s\n폜 */
		*( buffer + strlen(buffer) - 1 ) = '\0';
		
		/* Psڂɕ */
		split( buffer, ',', nameBuff, NUM_ITEMS );
		
		pLineNum = nameBuff[0];
		pShubetsu = nameBuff[1];
		gyoseiCode = atoi(nameBuff[2]);
		gunCode =  atoi(nameBuff[3]);
		name = nameBuff[4];
		gcjKanaZen2Han( nameBuff[5], kana, STRMAX ); /* SpЂ炪Ȃ𔼊pJiɕϊ */
		latitude = atof( nameBuff[6] );
		longitude = atof( nameBuff[7] );
		for ( i = 0; i < NEW_CODE_MAX; i++ ) newGyoseiCode[i] = atoi(nameBuff[8+i*2]);
		
		/* ̂̎ʁ@*/
		if ( strcmp( pShubetsu, KEN_NAME ) == 0 ) typeNum = TYPE_KEN;
		else if ( strcmp( pShubetsu, SHICHO_NAME ) == 0 ) typeNum = TYPE_SHICHO;
		else if ( strcmp( pShubetsu, GUN_NAME ) == 0 ) typeNum = TYPE_GUN;
		else if ( strcmp( pShubetsu, CHOSON_NAME ) == 0 ) typeNum = TYPE_CITY;
		else continue;
		
		/* ̂Q܂͂X𒴂ꍇُ͈@*/
		if ( strlen( name ) < 4 || strlen( name ) >= GYOSEI_NAME_LEN ) {
			printf(" sQ܂͂X𒴂Ă܂B line = %s  name = %s\n", pLineNum, name );
			continue;
		}

		/* s惌R[hԍe[uɓo^@*/
		if ( gyoseiCode < 1000 || gyoseiCode > GYOSEI_MAX ){
			printf(" sR[hiJISR[hj̒lُłBline = %d : code = %d\n", pLineNum, gyoseiCode );
			continue;
		}
		m_gyoseiRecordNum[ gyoseiCode ] = currentRecNum;


		/* s惌R[hzɊi[j@*/

		pGyoseiRec = &m_aryRecord[ currentRecNum ];

			/* */
		pGyoseiRec->shubetsu = typeNum;

			/* R[h */		
		kenCode = gyoseiCode / 1000;
		pGyoseiRec->kenCode = kenCode;

			/* x,S,s撬R[h̐ݒ@*/
		switch( typeNum ){
			case TYPE_KEN: 
				shichoCode = gunCode = cityCode = 0; 
				break;

			case TYPE_SHICHO: 
				shichoCode = gyoseiCode; 
				gunCode = cityCode = 0; 
				break;

			case TYPE_GUN:
				if ( kenCode == 1 ){	/* kC̏ꍇ */
					if ( gyoseiCode < 1300 ) shichoCode = 0;
					else shichoCode = GetShichoGunCode( gyoseiCode, 30 );
				}
				else shichoCode = 0;
				gunCode = gyoseiCode;
				cityCode = 0;
				break;
				
			case TYPE_CITY: 
				cityCode = gyoseiCode;
				if ( (gyoseiCode % 1000) < 300 ){	/* s於̏ꍇ */
					shichoCode = 0;

					/* ʋAߎwss̋̏ꍇ */
					if ( (cityCode % 1000) < 200 ){
						gunCode = kenCode * 1000 + 100 + 
							( (cityCode - kenCode * 1000 - 100) / 30 ) * 30;
					}
				}
				else {
					if ( kenCode == 1 ){	/* kC̏ꍇ@*/
						shichoCode = GetShichoGunCode ( gyoseiCode, 30 );
								/* SR[h͒ڃe[u擾 */
					}
					else if ( kenCode == 13 ){	/* s̏ꍇ */
						if ( gyoseiCode >= 13360 ){	/* ̏ꍇ */
							shichoCode = GetShichoGunCode ( gyoseiCode, 20 );
								/* SR[h͕ϑi䓇ƎOʂɐݒj */
						}
						else {
							shichoCode = 0;
							gunCode = GetShichoGunCode ( gyoseiCode, 20 );
						}
					}
					else if ( kenCode == 47 ){	/* ꌧ̏ꍇ */
						shichoCode = 0;
						if ( gyoseiCode > 47340 ){
							if ( gyoseiCode > 47380 ) gunCode = 47380;
							else if ( gyoseiCode > 47370 ) gunCode = 47370;
							else gunCode = 47340;
						}
						else 
							gunCode = GetShichoGunCode ( gyoseiCode, 20 );
					}
					else{
						shichoCode = 0;
						gunCode = GetShichoGunCode ( gyoseiCode, 20 );
					}
				}
				break;
		}
		pGyoseiRec->shichoCode = shichoCode;
		pGyoseiRec->gunCode = gunCode;
		pGyoseiRec->cityCode = cityCode;

			/* p~R[h */
		if ( newGyoseiCode[0] > 0 ) pGyoseiRec->removeFlag = 1;
		else pGyoseiRec->removeFlag = 0;

			/* Vs撬R[h */
		for ( i = 0; i < NEW_CODE_MAX; i++ )
							pGyoseiRec->newGyoseiCode[i] = newGyoseiCode[i];
		strncpy( pGyoseiRec->name, name, GYOSEI_NAME_LEN );
		strncpy( pGyoseiRec->kana, kana, GYOSEI_KANA_LEN );

		pGyoseiRec->latitude = dms2msec( latitude );
		pGyoseiRec->longitude = dms2msec( longitude );


			/* ̑AʃvOŋL */
		pGyoseiRec->choHashTableNum = 0;

		/* R[hԍ̍XV */	
		currentRecNum++;
		if ( currentRecNum == RECORD_MAX ){
			printf( "ʏNȂG[FRecord number error." );
			return -1;
		}
		
	}
	
	/* ʂ̃`FbN */
	if ( ferror( fpList ) ) {
		perror( "t@C̓ǂݍݒɃG[N܂B");
		return -1;
	}
	
	if ( currentRecNum == 1 ) {
		printf( "LȃR[h݂܂łB" );
		return -1;
	}

	
	/* t@Cwb_̏ */
			/* wb_̐ݒ */
	strcpy( m_gyoseiHeader.fileId, FILE_ID_GYOSEI );
	m_gyoseiHeader.version = 1;
	m_gyoseiHeader.numRecords = currentRecNum;

	n = fwrite( &m_gyoseiHeader, sizeof(m_gyoseiHeader), 1, fpRec );
	if ( !n ) {
		strcpy( errStr, "gyosei header write error." );
		goto err;
	}
	
	/* sR[h̏o@*/
	
		/*R[hԍe[u */
	n = fwrite( m_gyoseiRecordNum, sizeof(int), GYOSEI_MAX, fpRec );
	if ( n != GYOSEI_MAX ) {
		strcpy( errStr, "record number table write error" );
		goto err;
	}
	
		/* R[h{́@*/
	n = fwrite( m_aryRecord, sizeof(GYOSEI_RECORD), currentRecNum, fpRec );
	if ( n != currentRecNum ) {
		strcpy( errStr, "record write error" );
		goto err;
	}
	
	return 0;

err:
	printf( "t@C̏ݒɃG[N܂B%s\r\n", errStr );
	return -1;

}

/*
	s撬R[hx͌SR[h擾B
	
	cityCode  : Ts撬R[h
	numBundle : ̎xASɊ܂܂s
	
	߂l@T̎xASR[h
*/
int GetShichoGunCode( int gyoseiCode, int numBundle )
{
	int kenCode = gyoseiCode / 1000;
	int gunNum = ( gyoseiCode % 1000 - 300 ) / numBundle;
	int gunCode = 300 + gunNum * numBundle + kenCode * 1000;
	
	return gunCode;
}


/*
  Aw肵ŕAzɊi[B

	(in)
		 str 		:̕
	     delimiter  :؂蕶BpB
  		 numArray	:z̐
	(out) 
		aryStr		:z

  E؂蕶ŋ؂ꂽ255oCgȉłȂƂȂB
  
  ߂l@i[z̐
*/

int split( char *str, char delimiter, char aryStr[][256], int numArray )
{
	int numItems,i;
	unsigned char *pStart,*pEnd;

	for ( i = 0; i < numArray; i++ ) aryStr[i][0] = '\0';	
	numItems = 0;
	pStart = (unsigned char*) str;
	
	while( *pStart ){
		pEnd = _mbschr( pStart, (unsigned int)delimiter );
		if ( !pEnd ) break;
		
		*pEnd = '\0';
		if ( strlen( (char*)pStart )  > 255 ) *( pStart + 255 ) = '\0';
		strcpy( aryStr[ numItems ], (char*)pStart );
		numItems++;
		if ( numItems == numArray )  return(numItems);
		pStart = pEnd + 1;
	}
	if ( *pStart ){
		if ( strlen( (char*)pStart )  > 255 ) *( pStart + 255 ) = '\0';
		strcpy( aryStr[ numItems ], (char*)pStart );
		numItems++;
	}
	
	return numItems;
}


static int dms2msec( double dms )
{
	int deg,min;
	double degree,residue,sec;
	
	deg = (int) (dms / 10000);
	residue = dms - deg * 10000;
	min = (int)(residue / 100);
	sec = residue - min * 100;
	
	degree =  deg + min / 60.0 + sec / 3600.0;
	return (int)(degree * 3600000);
}
