/*
* [mkjukyo.cpp]
*
* Copyright (C) 2006 Orkney Inc., Kazuhide Kobayashi
*
*
*/



/*

 ȅZ{f[^ɂāA}ԏZԍR[ht@C쐬B
 ݃T|[gĂAZ{f[^͎̂ƂłB

 @PDCNgoАZf[^
 
  N@F mkjukyo gcjDbDir jukyoDirName

			gcjDbDir		: pZcai[ĂfBNg
			jukyoDirName	: 
				  gounnnnn.txt@̃t@Ci[ĂfBNg

	EpZcaɂ͎̃t@C݂Ȃ΂ȂȂB
		1Dgcj_gyosei.rec
		2. gcj_gyosei.hsh
		3. gcj_cho.rec
		4. gcj_cho.hsh
		5. gcj_aza.rec
		6. gcj_gaiku.rec
		
	ẼvO̎sApZDB̃fBNgɂ͎̃t@C
	@쐬B
		@1.}ԏZԍR[ht@Cigcj_jukyo.rec)

	@܂̃t@CXVB
		@1.nԊX敄R[ht@Cigcj_gaiku.rec)
			@
  t@CtH[}bgF
			}ԊX敄R[ht@CFGcjFileFormat#7
			
*/


/* wb_[@----------------------------------------------------------*/

#define _cplusplus_

#include "stdafx.h"
#include <windows.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <mbstring.h>
#include <time.h>
#include <tchar.h>


#include "geocoder.h"
#include "gcjlib.h"
#include "mkjukyo.h"

/* 萔` -----------------------------------------------------------*/


#define KOKUDO_DATA 1
#define INCP_DATA 2

#define CITY_MAX 4000

/* ϐ` -----------------------------------------------------------*/

char m_fileList[CITY_MAX][STRMAX+1];

	/* }ԏZԍt@C */
JUKYO_HEADER m_jukyoHeader;
JUKYO_TABLE_LIST m_jukyoTableList[ JUKYO_TABLE_MAX ];
JUKYO_RECORD *m_jukyoRecord;

int m_tableNum;
int m_numTotalRecords;


static char errStr[STRMAX+1];

/*@֐` ----------------------------------------------------------*/
int GetFileList( char *dirName, char fileList[][STRMAX+1] );
int MakeJukyoRecords( int sourceKind, char *fileName );
int RegisterTableNum( int cityCode, int choCode, int azaCode, int gaikuCode, int tableNum );
int MakeJukyoByIncp( char *fileName );

int main(int argc, char* argv[])
{
	FILE *fpJukyo;
	long nRet;
	char *dirName,*path;
	char *fileName,*jukyoFileName,*p;
	int i,numFiles,n,allocBytes,sourceKind,lastTotalRecords;
	time_t ltime;
	
	fpJukyo = NULL;
	m_jukyoRecord = NULL;
	
	if ( argc < 3 ) {
		printf(" mkjukyo gcjDbDir jukyoDirName \n" );
		return 0;
	}
	
	/* ̊m ------------------------------------------------------------*/
	
	m_jukyoRecord = (JUKYO_RECORD*) calloc( JUKYO_MAX, sizeof(JUKYO_RECORD) );
	if ( ! m_jukyoRecord ){
		allocBytes = JUKYO_MAX * sizeof(JUKYO_RECORD);
		sprintf( errStr, "#1 mۂł܂B mۂ悤ƂoCg = %d", allocBytes);
		goto err;
	}
	
	/* Zcã[h --------------------------------------------------------*/
	nRet = gcjDbLoad( argv[1], DB_GAIKU );
	if ( nRet < 0 ){
		sprintf( errStr, "#2 ZDBɃ[hł܂B %s",gcjDbErrorText() );
		goto err;
	}
	
	/* ̓t@C̐グ -------------------------------------------------*/
	dirName = argv[2];
	if ( strlen( dirName ) > 255 ){
		sprintf( errStr, "#3 fBNg255ȓɂĉB" );
		goto err;
	}
	
	numFiles = GetFileList( dirName, m_fileList );
	if ( numFiles == 0 ) {
		sprintf( errStr, "#4 w肵fBNgłt@C܂B" );
		goto err;
	}

	/* t@CIncPЃf[^̔f */
	sourceKind = 0;
	p = strrchr( m_fileList[0], '.' );
	if ( p ) {
		if ( strstr( m_fileList[0], "gou" ) && strstr( p, "txt" ) ) sourceKind = INCP_DATA;
	}
	if ( sourceKind == 0 ){
		sprintf( errStr, "#5 f[^̃t@C͌݃T|[gĂ܂B");
		goto err;
	}

	/* o̓t@Ci}ԏZԍj̃I[v */
	jukyoFileName = gcjDbFilePath( ID_JUKYO );
	fpJukyo = fopen( jukyoFileName, "wb" );
	if ( fpJukyo == NULL ){
		sprintf( errStr, "#6 t@C쐬ł܂B :  jukyoFileName = %s\n", jukyoFileName );
		goto err;
	}

	/* e̓t@CɂĎ}ԏZԍe[u쐬 ------------------------*/	
	m_numTotalRecords = 0;
	m_tableNum = 0;
	
	time( &ltime );	
	printf( "stat time = %s\n", ctime( &ltime ) );

	for ( i = 0; i < numFiles; i++ ){
		fileName = m_fileList[i];
		lastTotalRecords = m_numTotalRecords;
		printf( "**** start : file name = %s **** \n", fileName );
		nRet = MakeJukyoRecords( sourceKind, fileName );
		printf( "---- end   : file name = %s : nret = %d  : records = %d---- \n", 
							fileName, nRet, m_numTotalRecords - lastTotalRecords );
		
	}

	
	/* }ԏZԍR[ht@Cւ̏ó@----------------------------------*/

		/* wb_̐ݒ */
	strcpy( m_jukyoHeader.fileId, FILE_ID_JUKYO );
	m_jukyoHeader.version = 1;
	m_jukyoHeader.maxNumTables = m_tableNum;	/* ]Ɋmۂ͂Ȃ */
	m_jukyoHeader.numTables = m_tableNum;
	m_jukyoHeader.numTotalRecords = m_numTotalRecords;

	n = fwrite( &m_jukyoHeader, sizeof(m_jukyoHeader), 1, fpJukyo );

		/* e[uXg */
	n = fwrite( m_jukyoTableList, sizeof(JUKYO_TABLE_LIST), m_tableNum, fpJukyo );
	if ( n != m_tableNum ) {
		strcpy( errStr, "#7 t@CɃe[uXg݂̏ł܂B" );
		goto err;
	}
	
		/* R[h{́@*/
	n = fwrite( m_jukyoRecord, sizeof(JUKYO_RECORD), m_numTotalRecords, fpJukyo );
	if ( n != m_numTotalRecords ) {
		strcpy( errStr, "#8 t@CɃR[h݂̏ł܂B" );
		goto err;
	}

	/* ʃt@C̍XV ------------------------------------------------------*/
		/* nԊX敄t@C */
	path = gcjDbFilePath( ID_GAIKU );
	if ( path ) {
		n = GaikuRecSave( path );
		if ( n <= 0 ){
			sprintf( errStr, "#9 nԊX敄t@C̍XVł܂Bn = %d\n", n );
			goto err;
		}
	}
	
	/* I -------------------------------------------------------------------*/
	time( &ltime );	
	printf( "end time = %s\n", ctime( &ltime ) );
				
ret:
	gcjDbEnd();
	if (fpJukyo )  fclose( fpJukyo );
	if ( m_jukyoRecord ) free( m_jukyoRecord );
	return 0;
	
err:
	printf( errStr );
	goto ret;
}

/* 
	fBNgɂ錧܂͎št@C̃t@C擾B

	EfileList[][]̃t@C̓tpXŕԂB
	Ez̏ԂFindFirstFile()ŕԂ鏇ԂłAR[hł͂Ȃ

	Et@C͏ɕϊĕԂB
		
	߂l@Fi[t@C
	@@@ 0 : t@CȂ
*/

int GetFileList( char *dirName, char fileList[][STRMAX+1] )
{
	
	WIN32_FIND_DATA findData;
	HANDLE hFind;
	char buff[STRMAX];
	int i,j,len;

	strcpy( buff, dirName );
	strcat( buff, "\\*.*" );
	
	hFind = FindFirstFile( buff, &findData );
	if (hFind == INVALID_HANDLE_VALUE) return 0;
	
	i = 0;
	do {
		if ( findData.dwFileAttributes != FILE_ATTRIBUTE_DIRECTORY ) {
			strcpy( buff, dirName );
			strcat( buff, "\\" );
			strcat( buff, findData.cFileName );
			
			len = strlen( buff );
			for ( j = 0; j < len; j++ ) buff[j] = tolower( buff[j] );
			
			strcpy( fileList[i++], buff );
			if ( i == CITY_MAX ) break;
		}
	} while( FindNextFile( hFind, &findData ) );

    FindClose(hFind);

	return i;
}

/*
	Ps撬̎}ԏZԍR[h쐬B
 	 
	߂lF 0:@I
	@@@@-1F@G[
*/

int MakeJukyoRecords( int sourceKind, char *fileName )
{
	int nret;
	
	if ( sourceKind == INCP_DATA ) nret = MakeJukyoByIncp( fileName );
	else nret = 0;
	
	return nret;
}


/* nԊX敄R[ht@CɎ}ԏZԍe[uԍo^

	߂l
		0 : I
		-1: nԊX敄R[h擾łȂ
		-2: nԊX敄R[hݒłȂ
 */

int RegisterTableNum( int cityCode, int choCode, int azaCode, int gaikuCode, int tableNum )
{
	int n,nRet,jukyoHyoji;
	GAIKU_RECORD gaikuRecord;

	/* nԊX敄R[h̎擾 */
	n =  GaikuRecGet( cityCode, choCode, azaCode, gaikuCode, 
												 &gaikuRecord, &jukyoHyoji );
	if ( n < 0 ) { nRet = -1; goto ret; }

	gaikuRecord.jukyoTableNum = tableNum;
	n = GaikuRecPut( cityCode, choCode, azaCode, gaikuCode, &gaikuRecord );
	if ( n < 0 ) { nRet = -2; goto ret; }

	nRet = 0;

ret:
	return nRet;
}


/* łȂ}ԏZԍ̕nԕt@CɏށB

*/

STRING_HEADER m_strHeader;

int WriteChibanStr( char *chibanStr )
{
	FILE *fpStr;
	char buff[CHIBANSTR_BYTES],*fileName;
	int n,nRet;
	static int firstTime=1;
	
	if ( strlen( chibanStr ) > CHIBANSTR_BYTES ) return -1;

	fileName = gcjDbFilePath( ID_STRING );
	if ( !fileName ) return -2;

	/* t@C̃I[vƃwb_̐ݒ */	
	if ( GetFileAttributes( fileName ) == -1 || firstTime ){
		fpStr = fopen( fileName, "wb" );
		if ( !fpStr ) return -3;
		
		strcpy( m_strHeader.fileId, FILE_ID_STRING );
		m_strHeader.version = 1;
		m_strHeader.recordBytes = sizeof(buff);
		m_strHeader.numRecords = 1;
		
		firstTime = 0;
	}
	else {
		fpStr = fopen( fileName, "r+b" );
		if ( !fpStr ) return -4;
		
		n = fread( &m_strHeader, sizeof(m_strHeader), 1, fpStr );
		if ( n != 1 ) { nRet = -5; goto ret; }

		m_strHeader.numRecords++;
		fseek( fpStr, 0, SEEK_SET );
	}

	/* wb_̏ */
	n = fwrite( &m_strHeader, sizeof(m_strHeader), 1, fpStr );
	if ( n != 1 ) { nRet = -6; goto ret; }
		
	fseek( fpStr, 0, SEEK_END );

	/* ̏ */
	memset( buff, 0, sizeof(buff) );
	gcjStrcpy( buff, chibanStr, sizeof(buff) );
	n = fwrite( buff, sizeof(buff), 1, fpStr );
	if ( n != 1 ) { nRet = -7; goto ret; }

	nRet = m_strHeader.numRecords;
	
ret:
	fclose( fpStr );
	return nRet;
}

